<?php
/* **************************************************************************
File:		gmap.estategent.php
Estate Agent Improved Component for Joomla 1.5.x  
Version:	1.5.x 
Author:		Manos Orfanoudakis and EAImproved team
Homepage:	http://www.eaimproved.eu
License:	GNU/GPL http://www.gnu.org/copyleft/gpl.html
*************************************************************************** */



defined('_JEXEC') or die('Restricted access');

class GMapFunctions {
	function loadGMap($divName="admin",$point){
		global $mainframe,$eaconf;
		if(!$mainframe->get( 'ealoadGmap' )){
			GMapFunctions::loadAPI("<script src=\"http://maps.google.com/maps?file=api&amp;v=2&amp;key=$eaconf->ea_googlemap_key\" type=\"text/javascript\"></script>");
			if($point==null||$point=="")
				$point=$eaconf->ea_googlemap_sitemark;
ob_start();
?>
<script type="text/javascript">
//------------------------------------------
// GoogleMap api written for Estate Aagent Improved
// 2007 Manos Orfanoudakis
// http://www.eaimproved.eu
// Published under GNU GPL
//------------------------------------------
//<![CDATA[
var eagmap;
var geocoder = new GClientGeocoder();

	function showLocation(point){
		var parts=point.split(";");
		var lat = parseFloat( parts[0] );
	    var lon = parseFloat( parts[1] );
		lat = lat.toFixed(6);
		lon = lon.toFixed(6);
		var point=new GLatLng(lat,lon);
		eagmap.checkResize();
		eagmap.setCenter(point);
		eagmap.setZoom(parseInt(parts[2]));

	}
		
	function addPoint(point, text){
		var parts=point.split(";");
		var lat = parseFloat( parts[0] );
	    var lon = parseFloat( parts[1] );
		lat = lat.toFixed(6);
		lon = lon.toFixed(6);
		var point=new GLatLng(lat,lon);
		var marker = new GMarker(point);
		eagmap.checkResize();
		eagmap.addOverlay(marker);
		if(text){
			GEvent.addListener(marker, 'click',function(){
				marker.openInfoWindowHtml(text);			
			});
			
		}
		
		
	
	}
	function GMapload() {
		if (GBrowserIsCompatible()&&!eagmap) {
			eaGMapBeforeLoad();
			eagmap = new GMap2(document.getElementById("<?php echo $divName?>"));
		    eagmap.setCenter(new GLatLng(0,0), 10);
			eagmap.addControl(new GLargeMapControl());
			eagmap.setMapType(G_HYBRID_MAP);
			eagmap.addControl(new GMapTypeControl());
			//addPoint("$point");
			fixView();
			showLocation("<?php echo $point?>");
			eaGMapAfterLoad();
    	}
    }

function fixView(){
	eagmap.savePosition();
	eagmap.checkResize();
	eagmap.returnToSavedPosition();
	setTimeout('fixView()',1500);
}

	if (window.addEventListener) //DOM method for binding an event
	{
		window.addEventListener("unload", GUnload, false);
		window.addEventListener("load", GMapload, false);
	}
	else if (window.attachEvent) //IE exclusive method for binding an event
	{
		window.attachEvent("onunload", GUnload);
		window.attachEvent("onload", GMapload);
	}	
//]]>
</script>
<?php 
			$script= ob_get_contents();
			ob_end_clean();
			GMapFunctions::loadAPI($script);
			$mainframe->set( 'ealoadGmap', true );
		}
	}
	//Add script to document at the best possible position.
	function loadAPI($str){
		global $mainframe;
		if($mainframe->isAdmin()){
			echo $str;		
		}
		else{
			$mainframe->addCustomHeadTag($str);		
		}			
	}
	
	function configPane($pos){
		global $eaconf;
		GMapFunctions::loadGMap("admin",$pos);
		if($pos==null||$pos=="")
				$pos=$eaconf->ea_googlemap_sitemark;
		ob_start();
		?>
		<script type="text/javascript" >
		var form= document.adminForm;
 		function eaGMapBeforeLoad(){;}
		function eaGMapAfterLoad(){
			addPoint("<?php echo $pos ?>","<?php echo JText::_('_EAB_CFG_GOOGLEMAP_SAVED_LOCATION');?>");
			addGListener();
		}
		var usermarker;
		function refreshInput(overlay, point) {
			if(overlay){
				point=overlay.getPoint();
			}
			if (point) {
				if(usermarker)
					eagmap.removeOverlay(usermarker);
				//eagmap.clearOverlays() ;
				eagmap.setCenter(point);
				var marker = new GMarker(point);
				eagmap.addOverlay(marker);
				usermarker=marker;
				var matchll = /\(([-.\d]*), ([-.\d]*)/.exec( point );
				if ( matchll ) { 
            		var lat = parseFloat( matchll[1] );
				    var lon = parseFloat( matchll[2] );
					lat = lat.toFixed(6);
					lon = lon.toFixed(6);
					eagmap.checkResize();
					document.adminForm.ea_googlemap_sitemark.value = lat + ";" + lon+";"+eagmap.getZoom();
				} 
			}
		}
		function addGListener(){
			GEvent.addListener(eagmap, 'click',refreshInput);
		}
		</script>
		<?php 
		$script= ob_get_contents();
		ob_end_clean();
		GMapFunctions::loadAPI($script);
		?>
		<div style="width: auto; height: 500px;"  id="admin">
		</div>
	<?php
     
	}
	
	function adminPane($form,$savedLocation=null){
	global $eaconf,$mainframe;
	//Load map, with default shown location the saved point, with no init called..
	GMapFunctions::loadGMap("admin",$savedLocation);
	ob_start();
	?>	
		<script>
		var form;
		function eaGMapBeforeLoad(){form= document.<?php echo $form?>;}
		function eaGMapAfterLoad(){
			addGListener();
			fillLocationOptions();
			form.mapcoords.value = "<?php echo ($savedLocation==null&&$savedLocation=="")?$eaconf->ea_googlemap_sitemark:$savedLocation?>";
		}
		var usermarker;
		function refreshInput(overlay, point) {
			if(overlay){
				point=overlay.getPoint();
			}
			if (point) {
				if(usermarker)
					eagmap.removeOverlay(usermarker);
				//eagmap.clearOverlays() ;
				eagmap.setCenter(point);
				var marker = new GMarker(point);
				eagmap.addOverlay(marker);
				usermarker=marker;
				var matchll = /\(([-.\d]*), ([-.\d]*)/.exec( point );
				if ( matchll ) { 
            		var lat = parseFloat( matchll[1] );
				    var lon = parseFloat( matchll[2] );
					lat = lat.toFixed(6);
					lon = lon.toFixed(6);
					eagmap.checkResize();
					document.adminForm.mapcoords.value = lat + ";" + lon+";"+eagmap.getZoom();
				} 
			}
		}
		function addGListener(){
			GEvent.addListener(eagmap, 'click',refreshInput);
		}
		function getLocationString(){
		
			var elements = new Array(5);
			elements[4]=form.country.value;
			elements[3]=form.locstate.value;
			elements[2]=form.district.value;
			elements[1]=form.town.value;
			elements[0]=form.street.value + " " + form.streetnr.value;
			return elements.join(", ");		
		}
	
		function fillLocationOptions(){
			//Delete old records
			var element = form.GMapList;
			var optionCounter;
			while(element.options.length>0) { 
				element.options[0]=null;
			}
			eagmap.clearOverlays() ;
			geocoder.getLocations(
        	  getLocationString(),
	          function(response) {
				geo = document.getElementById("geocodestatus");
				if(response && response.Status.code == 200) {
	
					for(var i = 0; i< response.Placemark.length; i++){
						place = response.Placemark[i];
						address = place.address;
						element.options[element.options.length]=new Option(address, place.Point.coordinates[1]+";"+place.Point.coordinates[0]+";10",false);
						addPoint(place.Point.coordinates[1]+";"+place.Point.coordinates[0]+";10",address);
					}
					geo.innerHTML="<?php echo JText::_('_EAB_CFG_GOOGLEMAP_ADDRESS_SUCCESS');?>";
				}
				else {
					geo.innerHTML="<?php echo JText::_('_EAB_CFG_GOOGLEMAP_NO_ADDRESS');?>";
				}
			<?php			
			if($savedLocation!=null&&$savedLocation!=""){
			?>
				
				element.options[element.options.length]=new Option("<?php echo JText::_('_EAB_CFG_GOOGLEMAP_SAVED_LOCATION');?>","<?php echo $savedLocation?>",true);
				addPoint("<?php echo $savedLocation ?>","<?php echo JText::_('_EAB_CFG_GOOGLEMAP_SAVED_LOCATION');?>");
			<?php
			}
			?>
				element.options[element.options.length]=new Option("<?php echo JText::_('_EAB_CFG_GOOGLEMAP_SITE_MARK');?>","<?php echo $eaconf->ea_googlemap_sitemark?>",false);
				addPoint("<?php echo $eaconf->ea_googlemap_sitemark?>","<?php echo JText::_('_EAB_CFG_GOOGLEMAP_SITE_MARK');?>");
			
			}
	        );
		}
	</script>
	<?php 
	$script= ob_get_contents();
	ob_end_clean();
	GMapFunctions::loadAPI($script);
	?>
	<table width="100%">
	<tr>
	<td>
	<div align="center" style="text-align:center">
	
	<select name="GMapList" onchange="showLocation(this.value);form.mapcoords.value = this.value;" 
			onfocus="showLocation(this.value);form.mapcoords.value = this.value;"
			onBlur="showLocation(this.value);form.mapcoords.value = this.value;">
	</select>
	<input name="listloc" type="button" onclick="fillLocationOptions();return false;" value="Refresh" />
	<label name="geocodestatus" id="geocodestatus"></label>
	</div></td>
	</tr>
	<tr>
	<td style="text-align:center" align="center" >
	<div style="width:auto; height: 400px; text-align:center"  id="admin">
	</div>
	<div align="center" style="text-align:center">-------</div>
	<div align="center" style="text-align:center"><?php echo JText::_('_EAB_CFG_GOOGLEMAP_COORDINATES');?><input name="mapcoords"  size="25" value="<?php echo $savedLocation?>"  />
	</div>
	
	<div align="center" style="text-align:center"><?php echo JText::_('_EAB_CFG_GOOGLEMAP_EXPLANATION2');?></div>
	</td></tr></table>
	
	<?php		
	}
	function showMap($divName="gmap",$point=null,$text=null){
		global $eaconf;
		if($eaconf->ea_googlemap_enable==0) return ;
		//Redirect to site mark, if full location is hidden
		$point=$eaconf->ea_fulllocation==1?$point:$eaconf->ea_googlemap_sitemark;
		$point=$point==""?$eaconf->ea_googlemap_sitemark:$point;
		GMapFunctions::loadGMap($divName,$point);	
		ob_start();
		?>
		<script type="text/javascript">
		
		function eaGMapBeforeLoad(){;}
		function eaGMapAfterLoad(){
		<?php 	
		if($text&&$text!=""){?>
			addPoint("<?php echo $point?>","<?php echo $text?>");
		<?php }
		else {?>
			addPoint("<?php echo $point?>");
			
		<?php
		}?>
		}
		</script>
		<?php
		$script= ob_get_contents();
		ob_end_clean();
		GMapFunctions::loadAPI($script);
	}
	
}

?>