<?php
/* **************************************************************************
File:		object.estategent.php
Estate Agent Improved Component for Joomla 1.5.x  
Version:	1.5.x 
Based in:	Estate Agent  by D. Selesi
Author:		Manos Orfanoudakis and EAImproved team
Homepage:	http://www.eaimproved.eu
License:	GNU/GPL http://www.gnu.org/copyleft/gpl.html
*************************************************************************** */

defined('_JEXEC') or die('Restricted access');

class EAObject extends JTable {
    
    
	var $id = 0;
  	var $obj_id = 0;
  	var $cat = 0;
  	var $type = 0;
  	var $title = null;
  	var $description = null;
  	var $location = null;
  	var $condition = null;
  	var $other = null;
  	var $rooms = 0;
	var $bedrooms = 0;
	var $wc = 0;
  	var $space = 0;
  	var $homes = 0;
  	var $homes_size = 0;
  	var $pp_size = 0;
  	var $trade_units = 0;
  	var $trade_size = 0;
  	var $position = 0;
  	var $lift = 0;
	var $handicap = 0;
  	var $yobuilt = 0;
  	var $toheat = 0;
  	var $toheat_ufloor = 0;
  	var $fireside = 0;
	var $aircondition = 0;
	var $tv = 0;
	var $dsl = 0;	
	var $balcony = 0;
  	var $terrace = 0;
	var $swpool = 0;
  	var $garden = 0;
  	var $parkarea = 0;
  	var $garage = 0;
  	var $rent = 0;
  	var $rent_extra = 0;
  	var $price = 0;
  	var $commis = 0;
  	var $secure = 0;
  	var $receipts = 0;
  	var $street = null;
  	var $streetnr = 0;
  	var $pcode = 0;
  	var $town = null;
  	var $district = null;
  	var $locstate = null;
  	var $country = null;
  	var $hits = null;
  	var $hot = 0;
	var $mapcoords = '';
  	var $metadesc = null;
  	var $metakey = null;
  	var $created = 0;
  	var $created_by = 0;
  	var $access = 0;
  	var $publish_up = 0;
  	var $publish_down = 0;
  	var $published = 0;
	var $checked_out=0;
	var $checked_out_time=0;

  	function __construct( &$_db ) {
    	parent::__construct( '#__estateagent', 'id', $_db );
  	}
		
	function count_hits() {
		 
		 $query = "UPDATE #__estateagent SET hits=(hits+1) WHERE id=$this->id";
 	     $this->_db->setQuery($query);
 	     $this->_db->query();
	}
	/** Override default deletion method, to remove also the images of the object
	 */
	function delete($oid=null){
		
		if($oid){
			$this->id = $oid;
		}	
		$images=$this->getObjectImages();
		$img = new EAImage($this->_db);
					
		foreach($images as $i){
			$img->load($i);
			if(!$img->delete())
				return false;
		
		}
		/*Now delete self*/
		return parent::delete();
	
	}
	
	
			
	function parseShortInfo(&$obj){
		global $eaconf;
		static $vars ;
		 $vars = explode(",", $eaconf->ea_shortinfo);
		$res=array();
		foreach($vars as $var){
			if(isset($obj->$var)&&$obj->$var!=null){
				if(is_numeric($obj->$var))
					if($obj->$var==0)//Skip zero numbers...
						continue;
				$res[]=$obj->$var;
			}
		}
		return implode("/",$res);
	}	

	function getObjectImages($oid=null){
		
		if($oid){
			$this->id = $oid;
		}		
		$query = "SELECT id FROM #__estateagent_images WHERE objid ='".$this->id."'";
		$this->_db->setQuery($query);
		$result = $this->_db->loadResultArray();
				
		return $result;
	}


	function loadGallery($oid=null, $own=null) {
  		
		$my = &JFactory::getUser();
		$database =&JFactory::getDBO();

  		if($oid){
			$this->id = $oid;
			
		}
		
  		if($own == null) {
  			$database->setQuery("SELECT id,objid,title,description,fname,type,path FROM #__estateagent_images WHERE owner = $my->id AND objid != $this->id AND (type = '.jpg' OR type = '.gif' OR type = '.png') ORDER BY ordering ASC");
  		}
  		else{
  			$this->_db->setQuery( "SELECT * FROM #__estateagent_images WHERE objid = $this->id AND (type = '.jpg' OR type = '.gif' OR type = '.png') ORDER BY ordering ASC" );
  		}
  		$result =$this->_db->loadObjectList();
  		 if (count($result)==0) 	{
			//$this->_db->setQuery( "SELECT * FROM #__estateagent_images WHERE objid = 22 AND (type = '.jpg' OR type = '.gif' OR type = '.png') ORDER BY ordering ASC" );
			//$result2=new object ();
			$result2->id =0;	
			$result2->objid=0; 	
			$result2->title='aa'; 	
			$result2->description ='aa'; 	
			$result2->fname='nema_slike';	
			$result2->type='.jpg'; 	
			$result2->path='media/com_estateagent/pictures/';	
			$result2->owner=62; 	
			$result2->ordering=1; 	
			$result2->published=1;
			$result =Array();
			$result[]=$result2;
		 }
  		return $result;
  	}

	// for evaluation only ------------------------------------
	function loadFiles($oid=null,$t=null) {
  		//global $database, $my;
		$my = &JFactory::getUser();
  		//$database = &JFactory::getDBO();
		if($oid){
			$this->id = $oid;
		}
		if($t == null) {
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND type != '.jpg' AND type != '.gif' AND type != '.png' ORDER BY type,ordering ASC");
  			$result = $this->_db->loadObjectList();
		}
		else{
  			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND type = '.pdf' ORDER BY ordering ASC");
  			$result['pdf'] = $this->_db->loadObjectList();
  					
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND (type = '.avi' OR type = '.mov' OR type = '.mpg' OR type = '.swf') ORDER BY ordering ASC");
  			$result['mov'] = $this->_db->loadObjectList();
 			
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND (type = '.doc' OR type = '.xls' OR type = '.ppt') ORDER BY ordering ASC");
  			$result['msdoc'] = $this->_db->loadObjectList();
			
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND (type = '.odt' OR type = '.odp' OR type = '.ods') ORDER BY ordering ASC");
  			$result['ooffice'] = $this->_db->loadObjectList();
			
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND type = '.flv' ORDER BY ordering ASC");
  			$result['flv'] = $this->_db->loadObjectList();
			
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND type = '.mp4' ORDER BY ordering ASC");
  			$result['mp4'] = $this->_db->loadObjectList();
  		}
	
  		return $result;
  	}

	function country_select_list(){
		
		
		// to change the entries of the countries selectlist, edit this file and your languagefile			
		require(JPATH_SITE."/components/com_estateagent/includes/countries.inc.php");
			
		$c = array();
		while(list($key,$val) = each($countries)) { 
			$c[] = JHTML::_('select.option', $key, $val );	
			
		}
		return $c;		
	}

	function country_ISOtoName($c_iso){
		global $cntry;

		require(JPATH_SITE."/components/com_estateagent/includes/countries.inc.php");
		
		while(list($key,$val) = each($countries)) { 
			if($key == $c_iso){
				$cntry = $val;
				break;
			}
		}
		
		return $cntry;	
	}	

	function country_NameToISO($country){
		
		require(JPATH_SITE."/components/com_estateagent/includes/countries.inc.php");
		
		$iso_code = "";
		while(list($key,$val) = each($countries)) { 
			if($val == $country){
				$iso_code = $key;
				break;
			}
		}
		
		return $iso_code;	
	}	

}

?>