CREATE TABLE IF NOT EXISTS `#__estateagent` (
	`id` int(10) NOT NULL auto_increment,
  	`obj_id` varchar(25) NOT NULL default '',
  	`cat` int(10) NOT NULL default '0',
  	`type` tinyint(2) NOT NULL default '0',
  	`title` varchar(255) NOT NULL default '',
  	`description` text NOT NULL default '',
	`location` text NOT NULL default '',
	`condition` text NOT NULL default '',
	`other` text NOT NULL default '',
  	`rooms` smallint(4) NOT NULL default '0',
	`bedrooms` smallint(4) NOT NULL default '0',
	`wc` smallint(4) NOT NULL default '0',
  	`space` decimal(10,2) NOT NULL default '0.00',
  	`homes` smallint(5) NOT NULL default '0',
  	`homes_size` decimal(10,2) NOT NULL default '0.00',
  	`pp_size` decimal(10,2) NOT NULL default '0.00',
  	`trade_units` smallint(5) NOT NULL default '0',
  	`trade_size` decimal(10,2) NOT NULL default '0.00',
  	`position` varchar(50) NOT NULL default '',
  	`lift` tinyint(1) NOT NULL default '0',
	`handicap` tinyint(1) NOT NULL default '0',
  	`yobuilt` varchar(10) NOT NULL default '',
  	`toheat` tinytext NOT NULL default '',
  	`toheat_ufloor` tinyint(1) NOT NULL default '0',
	`fireside` tinyint(1) NOT NULL default '0',
	`aircondition` tinyint(1) NOT NULL default '0',
	`tv` tinyint(1) NOT NULL default '0',
	`dsl` tinyint(1) NOT NULL default '0',
	`swpool` tinyint(1) NOT NULL default '0',
  	`balcony` tinyint(1) NOT NULL default '0',
  	`terrace` tinyint(1) NOT NULL default '0',
  	`garden` tinyint(1) NOT NULL default '0',
  	`parkarea` tinyint(1) NOT NULL default '0',
  	`garage` tinyint(1) NOT NULL default '0',
  	`rent` decimal(10,2) NOT NULL default '0.00',
  	`rent_extra` decimal(10,2) NOT NULL default '0.00',
  	`price` decimal(10,2) NOT NULL default '0.00',
  	`commis` varchar(15) NOT NULL default '',
  	`secure` decimal(10,2) NOT NULL default '0.00',
  	`receipts` decimal(10,2) NOT NULL default '0.00',
  	`street` varchar(255) NOT NULL default '',
  	`streetnr` varchar(5) NOT NULL default '',
  	`pcode` varchar(10) NOT NULL default '',
  	`town` tinytext NOT NULL default '',
  	`district` tinytext NOT NULL default '',
  	`locstate` tinytext NOT NULL default '',
  	`country` tinytext NOT NULL default '',
  	`hits` int(6) NOT NULL default '0',
  	`hot` tinyint(1) NOT NULL default '0',
	`mapcoords` TINYTEXT NOT NULL DEFAULT '',
  	`metadesc` varchar(255) NOT NULL default '',
  	`metakey` varchar(255) NOT NULL default '',
  	`created` date NOT NULL default '0000-00-00',
  	`created_by` int(11) NOT NULL default '0',
  	`access` tinyint(3) NOT NULL default '0',
  	`publish_up` date NOT NULL default '0000-00-00',
  	`publish_down` date NOT NULL default '0000-00-00',
  	`published` tinyint(1) NOT NULL default '1',
	`checked_out` tinyint(1) NOT NULL default '0',
	`checked_out_time` time default NULL,
  	PRIMARY KEY  (`id`),
  	UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM CHARACTER SET 'utf8' COLLATE 'utf8_general_ci';



CREATE TABLE IF NOT EXISTS `#__estateagent_categories` (
  	`id` int(10) NOT NULL auto_increment,
  	`name` varchar(255) NOT NULL default '',
  	`description` text NOT NULL default '',
  	`entries` int(10) NOT NULL default '0',
  	`parent` int(10) NOT NULL default '0',
  	`ordering` tinyint(4) NOT NULL default '0',
  	`access` tinyint(3) NOT NULL default '0',
  	`publish_up` date NOT NULL default '0000-00-00',
  	`publish_down` date NOT NULL default '0000-00-00',
  	`published` tinyint(1) NOT NULL default '1',
  	UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM CHARACTER SET 'utf8' COLLATE 'utf8_general_ci';


CREATE TABLE IF NOT EXISTS `#__estateagent_images` (
  	`id` int(10) NOT NULL auto_increment,
  	`objid` int(10) NOT NULL default '0',
  	`title` varchar(50) NOT NULL default '',
  	`description` varchar(255) NOT NULL default '',
 	`fname` varchar(30) NOT NULL default '',
  	`type` varchar(5) NOT NULL default '',
  	`path` varchar(255) NOT NULL default '',
  	`owner` int(11) NOT NULL default '0',
  	`ordering` tinyint(4) NOT NULL default '0',
  	`published` tinyint(1) default '1',
  	UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM CHARACTER SET 'utf8' COLLATE 'utf8_general_ci';