<?php
/**
 * @package Sigsiu Online Business Index 2
 * @subpackage Backup Restore Plugin
 * ===================================================
 * @copyright Copyright (C) 2007 Sigsiu.NET (http://www.sigsiu.net). All rights
 * reserved.
 * @license This plugin is released under Proprietary Commercial License. You may
 * use this extension on one SOBI2 installation only. To use it on more sites, you
 * need to buy extra license  for each. You may not resell, distribute or publish
 * this extension or parts (code snippets) of it.
 * @author Name: Sigrid & Radek Suski, Sigsiu.NET
 * Email: sobi@sigsiu.net
 * Url: http://www.sigsiu.net
 * ===================================================
 * @version $Id: backupRestore_html.php 4053 2008-06-07 14:38:46Z Radek Suski $
 * @updated 17-Mar-2008 5:27:22 PM
 */
defined( "_SOBI2_" )  || ( trigger_error( "Restricted access", E_USER_ERROR ) && exit() );
class backupRestore_html
{
	/**
	 * Enter description here...
	 *
	 * @param sobi_backupRestore_adm $p
	 */
	function config( &$p )
	{
		$config =& sobi2Config::getInstance();
		$config->loadScript( "advajax" );
		$config->addCustomScript( '
			var SBP_exOpt;
			function SBPselectOption( section, option )
			{
				if( option == 0 ) {
					return false;
				}
				targCont = "SBP"+ section +"OptCont";
				task = "load_"+ option + "_" + section + "_screen";
				loader = section + "LoaderCont";
				box = section + "SelectBox";
				advAJAX.get({
				    url: "index3.php",
					parameters : {
					      "no_html" : "1",
					      "option" : "com_sobi2",
					      "task" : task
					},
					onInitialization : function() {
						document.getElementById( loader ).innerHTML = "&nbsp;<img style=\"border: solid 1px;\" src=\"'.$config->liveSite.'/administrator/components/com_sobi2/images/progress.gif\" alt=\"progress\" title=\"progress\"/>";
						document.getElementById( box ).disabled = true;
					},
				    onSuccess : function( obj ) {
				        document.getElementById( targCont ).innerHTML = obj.responseText;
						document.getElementById( loader ).innerHTML = "";
						document.getElementById( box ).disabled = false;
						SBP_exOpt = option;
				    },
				    onError : function( obj ) {
				    	alert( "Error: " + obj.status );
				    }
				});
			}

			function SBPsaveOption( section )
			{
				if( section == "import") {
					option = document.getElementById("importSelectBox").options[document.getElementById("importSelectBox").selectedIndex].value;
				}
				else {
					option = document.getElementById("exportSelectBox").options[document.getElementById("exportSelectBox").selectedIndex].value;
				}
				if( option == 0 ) {
					return false;
				}
				saveTask = "save_"+ option + "_" + section;
				document.getElementById( "task" ).value = saveTask;
				box = section + "SelectBox";
				loader = section + "LoaderCont";
				document.getElementById("adminForm").action = "index3.php";
				advAJAX.submit(document.getElementById("adminForm"),
				{
					onInitialization : function(obj) {
						document.getElementById( loader ).innerHTML = "&nbsp;<img style=\"border: solid 1px;\" src=\"'.$config->liveSite.'/administrator/components/com_sobi2/images/progress.gif\" alt=\"progress\" title=\"progress\"/>";
						document.getElementById( box ).disabled = true;
						document.getElementById( "SBPExOptBt" ).disabled = true;
					},
					onSuccess : function(obj) {
						SBPselectOption( section, SBP_exOpt );
						document.getElementById( "SBPExOptBt" ).disabled = false;
					},
					onError : function(obj) {
						alert( "Error: " + obj.status );
					}
				}
				);
			}
			function SBPStartExport( section )
			{
				if( confirm("'.$p->txt( "js_on_export_start_msg" ).'") ) {
					document.getElementById( "SBPiFrame" ).src= "index3.php?option=com_sobi2&task=start_" + section + "_export&no_html=1";
				}
				else {
					return false;
				}
			}
			function SBPStartImport( section )
			{
				document.getElementById( "SBPiiFrame" ).src= "index3.php?option=com_sobi2&task=start_" + section + "_import&no_html=1";
			}
		' );
		?>
		<script type="text/javascript">document.getElementById( "sobitoolbar" ).style.display = "none";</script>
	 	<table class="adminform" width="100%" border="1">
			<tr>
				<th><?php echo $p->name;?></th>
			</tr>
			<tr>
				<td>
				<?php
					$tabs = new sobiTabs( true );
					$tabs->startPane("backup");

					$tabs->startTab( $p->txt( "welcome_screen" ), "welcometScreen");
					backupRestore_html::welcomeScreen( $p );
					$tabs->endTab();

					$tabs->startTab( $p->txt( "export_options" ), "exportOpt");
					backupRestore_html::exportOpt( $p );
					$tabs->endTab();

					$tabs->startTab( $p->txt( "export_screen" ), "exportScreen");
					backupRestore_html::exportScreen( $p );
					$tabs->endTab();

					$tabs->startTab( $p->txt( "import_options" ), "importOpt");
					backupRestore_html::importOpt( $p );
					$tabs->endTab();

					$tabs->startTab( $p->txt( "import_screen" ), "exportScreen");
					backupRestore_html::importScreen( $p );
					$tabs->endTab();

					$tabs->endPane();
				?>
				</td>
			</tr>
		</table>
		<input type="hidden" name="option" value="com_sobi2" />
		<input type="hidden" name="no_html" value="1" />
		<?php
	}
	/**
	 * Enter description here...
	 * @param sobi_backupRestore_adm $p
	 */
	function welcomeScreen( &$p )
	{
		$ctime = $p->lastTablesBackup();
		$config =& sobi2Config::getInstance();
		if( $ctime == $p->txt( "never" ) ) {
			$dis = ' disabled="disabled" ';
		}
		else {
			$dis = null;
		}
		?>
	 	<table class="adminform" border="1" >
			<tr class="row0">
				<td height="75" width="100" colspan="2"><div style="text-align:left; width: 100%; padding:5px;"><?php echo $p->txt( "welcome_screen_text"); ?></div></td>
			</tr>
			<tr class="row1">
				<td height="75" width="150"  style="text-align:center">
					<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/tables.png" alt="" style="border-style:none;" />
					<br/>
					<?php echo $p->txt( "backup_restore_tables"); ?>
				</td>
				<td>
					<div style="text-align:left; width: 100%; padding:5px;">
						<br/>
						<?php echo $p->txt( "backup_restore_tables_expl"); ?>
						<br/><br/>
						<?php echo $p->txt( "last_backup_tables"); ?><b><?php echo $ctime;?></b>
						<br/><br/>
						<input type="button" class="button" value="<?php echo $p->txt( "backup_tables" ); ?>" onclick="if(confirm('<?php echo $p->txt( "js_confirm_backup_tables" ); ?>')){ window.location.href = 'index2.php?option=com_sobi2&task=br_backup_tables'; }"/>
						&nbsp;
						<input type="button" class="button" value="<?php echo $p->txt( "restore_tables" ); ?>"  <?php echo $dis; if( $dis == null ) { ?> onclick="if(confirm('<?php echo $p->txt( "js_confirm_restore_tables" ); ?>')){ if(confirm('<?php echo $p->txt( "js_confirm_restore_tables_2" ); ?>')) { window.location.href = 'index2.php?option=com_sobi2&task=br_restore_tables'; } }" <?php } ?> />
						<br/>&nbsp;
					</div>
				</td>
			</tr>
			<tr class="row0">
				<td height="75" width="150"  style="text-align:center">
					<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/clone.png" alt="" style="border-style:none;" />
					<br/>
					<?php echo $p->txt( "clone_settings"); ?>
				</td>
				<td>
					<div style="text-align:left; width: 100%; padding:5px;">
						<?php echo $p->txt( "clone_settings_expl"); ?>
						<br/><br/><br/>
						<input type="button" style="width: 450px; " class="button" value="<?php echo $p->txt( "clone_entries_e_to_i" ); ?>" onclick="if(confirm('<?php echo $p->txt( "js_confirm_clone" ); ?>')){ window.location.href = 'index2.php?option=com_sobi2&task=br_clone_entries_e_to_i'; }"/>
						<br/><br/>
						<input type="button" style="width: 450px; " class="button" value="<?php echo $p->txt( "clone_entries_i_to_e" ); ?>" onclick="if(confirm('<?php echo $p->txt( "js_confirm_clone" ); ?>')){ window.location.href = 'index2.php?option=com_sobi2&task=br_clone_entries_i_to_e'; }"/>
						<br/><br/>
						<input type="button" style="width: 450px; " class="button" value="<?php echo $p->txt( "clone_cats_e_to_i" ); ?>" onclick="if(confirm('<?php echo $p->txt( "js_confirm_clone" ); ?>')){ window.location.href = 'index2.php?option=com_sobi2&task=br_clone_cats_e_to_i'; }"/>
						<br/><br/>
						<input type="button" style="width: 450px; " class="button" value="<?php echo $p->txt( "clone_cats_i_to_e" ); ?>" onclick="if(confirm('<?php echo $p->txt( "js_confirm_clone" ); ?>')){ window.location.href = 'index2.php?option=com_sobi2&task=br_clone_cats_i_to_e'; }"/>
						<br/><br/>
						<input type="button" style="width: 450px; " class="button" value="<?php echo $p->txt( "clone_fields_e_to_i" ); ?>" onclick="if(confirm('<?php echo $p->txt( "js_confirm_clone" ); ?>')){ window.location.href = 'index2.php?option=com_sobi2&task=br_clone_fields_e_to_i'; }"/>
						<br/><br/>
						<input type="button" style="width: 450px; " class="button" value="<?php echo $p->txt( "clone_fields_i_to_e" ); ?>" onclick="if(confirm('<?php echo $p->txt( "js_confirm_clone" ); ?>')){ window.location.href = 'index2.php?option=com_sobi2&task=br_clone_fields_i_to_e'; }"/>
					</div>
				</td>
			</tr>
<!--			<tr class="row0">
				<td height="75" width="150"  style="text-align:center">
					<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/restore.png" alt="" style="border-style:none;" />
					<?php echo $p->txt( "restore_default"); ?>
				</td>
				<td>
					<?php echo $p->txt( "restore_default_expl"); ?>
				</td>
			</tr>
-->		</table>
		<?php
	}
	/**
	 * Enter description here...
	 *
	 */
	function exportScreen( &$p )
	{
		$config =& sobi2Config::getInstance();
		?>
	 	<table class="adminform" width="100%" border="1">
			<tr class="row1">
				<td height="100">
				<div style="text-align:center;">
					<a style="cursor:pointer;" onclick="SBPStartExport('entries')">
						<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/entries.png" alt="" style="border-style:none;" />
					</a>
					<br/>
					<a style="cursor:pointer;" onclick="SBPStartExport('entries')">
						<?php echo $p->txt( "export_entries"); ?>
					</a>
				</div>
				</td>
				<td>
				<div style=" text-align:center;">
					<a style="cursor:pointer;" onclick="SBPStartExport('cats')">
						<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/categories.png" alt="" style="border-style:none;" />
					<br/>
					<a style="cursor:pointer;" onclick="SBPStartExport('cats')">
						<?php echo $p->txt( "export_categories"); ?>
					</a>
				</div>
				</td>
				<td>
				<div style=" text-align:center;">
					<a style="cursor:pointer;" onclick="SBPStartExport('fields')">
						<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/fields.png" alt="" style="border-style:none;" />
					<br/>
					<a style="cursor:pointer;" onclick="SBPStartExport('fields')">
						<?php echo $p->txt( "export_fields"); ?>
					</a>
				</div>
				</td>
				<td>
				<div style=" text-align:center;">
					<a style="cursor:pointer;" onclick="SBPStartExport('config')">
						<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/config.png" alt="" style="border-style:none;" />
					<br/>
					<a style="cursor:pointer;" onclick="SBPStartExport('config')">
						<?php echo $p->txt( "export_config"); ?>
					</a>
				</div>
				</td>
			</tr>
			<tr class="row0">
				<td height="400" valign="top" colspan="4">
					<iframe id="SBPiFrame" height="400" width="100%" style="border-style:none;"></iframe>
				</td>
			</tr>
		</table>
		<?php
	}
	/**
	 * Enter description here...
	 *
	 */
	function importScreen( &$p )
	{
		$config =& sobi2Config::getInstance();
		?>
	 	<table class="adminform" width="100%" border="1">
			<tr class="row1">
				<td height="100">
				<div style="text-align:center;">
					<a style="cursor:pointer;" onclick="SBPStartImport('entries')">
						<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/entries.png" alt="" style="border-style:none;" />
					</a>
					<br/>
					<a style="cursor:pointer;" onclick="SBPStartImport('entries')">
						<?php echo $p->txt( "import_entries"); ?>
					</a>
				</div>
				</td>
				<td>
				<div style=" text-align:center;">
					<a style="cursor:pointer;" onclick="SBPStartImport('cats')">
						<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/categories.png" alt="" style="border-style:none;" />
					<br/>
					<a style="cursor:pointer;" onclick="SBPStartImport('cats')">
						<?php echo $p->txt( "import_categories"); ?>
					</a>
				</div>
				</td>
				<td>
				<div style=" text-align:center;">
					<a style="cursor:pointer;" onclick="SBPStartImport('fields')">
						<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/fields.png" alt="" style="border-style:none;" />
					<br/>
					<a style="cursor:pointer;" onclick="SBPStartImport('fields')">
						<?php echo $p->txt( "import_fields"); ?>
					</a>
				</div>
				</td>
				<td>
				<div style=" text-align:center;">
					<a style="cursor:pointer;" onclick="SBPStartImport('config')">
						<img src="<?php echo $config->liveSite;?>/administrator/components/com_sobi2/plugins/backup/config.png" alt="" style="border-style:none;" />
					<br/>
					<a style="cursor:pointer;" onclick="SBPStartImport('config')">
						<?php echo $p->txt( "import_config"); ?>
					</a>
				</div>
				</td>
			</tr>
			<tr class="row0">
				<td height="600" valign="top" colspan="4">
					<iframe id="SBPiiFrame" height="400" width="100%" style="border-style:none;"></iframe>
				</td>
			</tr>
		</table>
		<?php
	}
	/**
	 *
	 * @param string $title
	 * @param array $msg
	 */
	function summaryScreen( $title, $msg )
	{
		sobi2Config::debOut( $title );
		sobi2Config::debOut( implode( "<br/>", $msg ) );
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 */
	function exportOpt( &$p )
	{
		$o = array(
			sobiHTML::makeOption( "0", 			$p->txt( "select" ) ),
			sobiHTML::makeOption( "entries", 	$p->txt( "select_entries_export_options" ) ),
			sobiHTML::makeOption( "cats", 		$p->txt( "select_categories_export_options" ) ),
			sobiHTML::makeOption( "fields", 	$p->txt( "select_fields_export_options" ) ),
			sobiHTML::makeOption( "config", 	$p->txt( "select_config_export_options" ) )
		);
		$select = sobiHTML::selectList( $o, "fl_ordering", 'onchange="SBPselectOption( \'export\', this.options[this.selectedIndex].value )" size="1" class="text_area" id="exportSelectBox"' , 'value', 'text' );
		?>
	 	<table class="adminform" width="100%" border="1">
			<tr class="row1">
				<td>
					<?php echo $p->txt( "please_select_export_options_to_configure"); ?>
					&nbsp;
					<?php echo $select; ?>
					<input type="button" id="SBPExOptBt" class="button" value="<?php echo $p->txt( "save_settings"); ?>" onclick="SBPsaveOption('export')" align="right"/>
					<span id="exportLoaderCont"></span>
				</td>
			</tr>
			<tr class="row0">
				<td height="500" valign="top">
					<div id="SBPexportOptCont"></div>
				</td>
			</tr>
		</table>
		<?php
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 */
	function exportConfigOpt( &$p )
	{
		?>
		<table class="SobiAdminForm" width="100%">
		  	<tr class="row1">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "export_config_configuration_settings" ); ?></th>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left; width: 150px;">
					<?php echo $p->txt( "config_export_sobi_configuration_keys" ); ?>
				</td>
				<td style="text-align:left; width: 150px;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPesExportConfigKeys', 'class="text_area"', $p->esExportConfigKeys );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_export_sobi_configuration_keys_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "config_export_sobi_registry" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPesExportReg', 'class="text_area"', $p->esExportReg );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_export_sobi_registry_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "config_export_sobi_templates" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPesExportTpls', 'class="text_area"', $p->esExportTpls );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_export_sobi_templates_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "config_export_sobi_css" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPesExportCSS', 'class="text_area"', $p->esExportCSS );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_export_sobi_css_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "config_export_sobi_custom_functions" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPesExportCustomFunction', 'class="text_area"', $p->esExportCustomFunction );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_export_sobi_custom_functions_expl" ); ?>
				</td>
		    </tr>
		</table>
		<?php
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 */
	function exportCatOpt( &$p )
	{
		$rows = backupRestore_engine::getCatRows();
		$o = array();
		$o[] = sobiHTML::makeOption( "dnu", $p->txt( "field_do_no_use_option" ) );
		$o[] = sobiHTML::makeOption( "empty", $p->txt( "field_empty_option" ) );
		for( $i = 0; $i < count( $rows ); $i++ ) {
			$o[] = sobiHTML::makeOption( $rows[$i], $rows[$i] );
		}
		?>
		<table class="SobiAdminForm" width="100%">
		  	<tr class="row1">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "export_categories_configuration_settings" ); ?></th>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left; width: 150px;">
					<?php echo $p->txt( "categories_values_separator" ); ?>
				</td>
				<td style="text-align:left; width: 150px;">
					<input type="text" class="text_area" name="SBPecSep" style="text-align:center" value="<?php echo $p->ecSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_values_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_loop_limit" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPecLim" style="text-align:center" value="<?php echo $p->ecLim; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_loop_limit_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_discharging_pause" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPecPause" style="text-align:center" value="<?php echo $p->ecPause; ?>" size="5" maxlength="5"/>
					<?php echo $p->txt( "seconds" ); ?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_discharging_pause_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_export_filter_html_code" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPecFilterHtml', 'class="text_area"', $p->ecFilterHtml );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_export_filter_html_code_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_export_filter_separator" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPecFilterSep', 'class="text_area"', $p->ecFilterSep );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_export_filter_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_export_images_too" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPecImg', 'class="text_area"', $p->ecImg );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_export_images_too_expl" ); ?>
				</td>
		    </tr>
		  	<tr class="row0">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "categories_set_the_fields_order_for_the_csv_file" ); ?></th>
		    </tr>
		    <tr class="row1">
				<td colspan="3" style="text-align:left;">
					<?php echo $p->txt( "categories_set_the_fields_order_for_the_csv_file_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td colspan="3" style="text-align:left;">
				<table class="SobiAdminForm" width="600">
				<tr>
				<td>
				<?php
					$fc = count( $rows );
					$cr = ceil( $fc / 3 );
					for( $i = 0; $i < $fc; $i++ ) {
						if( $i%$cr == 0 ) {
							echo "</td><td>";
						}
						$c = sprintf( "%02d", ( $i + 1 ) );
						if( is_array( $p->ecFieldsOrder ) && isset( $p->ecFieldsOrder[$i] ) ) {
							$s = $p->ecFieldsOrder[$i];
						}
						else {
							if( is_array( $p->ecFieldsOrder ) && !empty( $p->ecFieldsOrder ) ) {
								$s = "dnu";
							}
							else {
								$s = $rows[$i];
							}
						}
						echo "<b>[</b>&nbsp;{$c}&nbsp;";
						echo sobiHTML::selectList( $o, "SBPcfield[{$i}]", '' , 'value', 'text', $s );
						echo "<b>&nbsp;]&nbsp;&nbsp;";
						echo $p->ecSep;
						echo "&nbsp;</b>&nbsp;<br/>";
					}
				?>
				</td>
				</tr>
				</table>
				</td>
		    </tr>
		</table>
		<?php
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 * @param array $fields
	 */
	function exportEntriesOpt( &$p, $fields )
	{
		$o = array();
		$o[] = sobiHTML::makeOption( "dnu", $p->txt( "field_do_no_use_option" ) );
		$o[] = sobiHTML::makeOption( "empty", $p->txt( "field_empty_option" ) );
		for( $i = 0; $i < count( $fields ); $i++ ) {
			$o[] = sobiHTML::makeOption( $fields[$i], $fields[$i] );
		}
		?>
		<table class="SobiAdminForm" width="100%">
		  	<tr class="row1">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "export_entries_configuration_settings" ); ?></th>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left; width: 200px;">
					<?php echo $p->txt( "entry_values_separator" ); ?>
				</td>
				<td style="text-align:left; width: 150px;">
					<input type="text" class="text_area" name="SBPeSep" style="text-align:center" value="<?php echo $p->eSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_values_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_categories_separator" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPeCatSep" style="text-align:center" value="<?php echo $p->eCatSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_categories_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_multivalues_separator" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPeMValSep" style="text-align:center" value="<?php echo $p->eMValSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_multivalues_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_loop_limit" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPeLim" style="text-align:center" value="<?php echo $p->eLim; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_loop_limit_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_discharging_pause" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPePause" style="text-align:center" value="<?php echo $p->ePause; ?>" size="5" maxlength="5"/>
					<?php echo $p->txt( "seconds" ); ?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_discharging_pause_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_filter_html_code" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPeFilterHtml', 'class="text_area"', $p->eFilterHtml );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_filter_html_code_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_filter_separator" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPeFilterSep', 'class="text_area"', $p->eFilterSep );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_filter_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_images_too" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPeImg', 'class="text_area"', $p->eImg );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_export_images_too_expl" ); ?>
				</td>
		    </tr>
		  	<tr class="row0">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "set_the_fields_order_for_the_csv_file" ); ?></th>
		    </tr>
		    <tr class="row1">
				<td colspan="3" style="text-align:left;">
					<?php echo $p->txt( "set_the_fields_order_for_the_csv_file_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td colspan="3" style="text-align:left;">
				<table class="SobiAdminForm" width="600">
				<tr>
				<td>
				<?php
					$fc = count( $fields );
					$cr = ceil( $fc / 3 );
					for( $i = 0; $i < $fc; $i++ ) {
						if( $i%$cr == 0 ) {
							echo "</td><td>";
						}
						$c = sprintf( "%02d", ( $i + 1 ) );
						if( is_array( $p->eFieldsOrder ) && isset( $p->eFieldsOrder[$i] ) ) {
							$s = $p->eFieldsOrder[$i];
						}
						else {
							if( is_array( $p->eFieldsOrder ) && !empty( $p->eFieldsOrder ) ) {
								$s = "dnu";
							}
							else {
								$s = $fields[$i];
							}

						}
						echo "<b>[</b>&nbsp;{$c}&nbsp;";
						echo sobiHTML::selectList( $o, "SBPfield[{$i}]", '' , 'value', 'text', $s );
						echo "<b>&nbsp;]&nbsp;&nbsp;";
						echo $p->eSep;
						echo "&nbsp;</b>&nbsp;<br/>";
					}
				?>
				</td>
				</tr>
				</table>
				</td>
		    </tr>
		</table>
		<?php
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 */
	function exportFieldsOpt( &$p )
	{
		$fields = backupRestore_engine::getFieldRows();
		$o = array();
		$o[] = sobiHTML::makeOption( "dnu", $p->txt( "field_do_no_use_option" ) );
		$o[] = sobiHTML::makeOption( "empty", $p->txt( "field_empty_option" ) );
		for( $i = 0; $i < count( $fields ); $i++ ) {
			$o[] = sobiHTML::makeOption( $fields[$i], $fields[$i] );
		}
		?>
		<table class="SobiAdminForm" width="100%">
		  	<tr class="row1">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "export_fields_configuration_settings" ); ?></th>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left; width: 200px;">
					<?php echo $p->txt( "fields_values_separator" ); ?>
				</td>
				<td style="text-align:left; width: 150px;">
					<input type="text" class="text_area" name="SBPefSep" style="text-align:center" value="<?php echo $p->efSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "fields_values_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "fields_fields_multivalues_separator" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPefMValSep" style="text-align:center" value="<?php echo $p->efMValSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "fields_export_multivalues_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "fields_export_filter_separator" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPefFilterSep', 'class="text_area"', $p->efFilterSep );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "fields_export_filter_separator_expl" ); ?>
				</td>
		    </tr>
		  	<tr class="row0">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "fields_set_the_fields_order_for_the_csv_file" ); ?></th>
		    </tr>
		    <tr class="row1">
				<td colspan="3" style="text-align:left;">
					<?php echo $p->txt( "fields_set_the_fields_order_for_the_csv_file_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td colspan="3" style="text-align:left;">
				<table class="SobiAdminForm" width="600">
				<tr>
				<td>
				<?php
					$fc = count( $fields );
					$cr = ceil( $fc / 3 );
					for( $i = 0; $i < $fc; $i++ ) {
						if( $i%$cr == 0 ) {
							echo "</td><td>";
						}
						$c = sprintf( "%02d", ( $i + 1 ) );
						if( is_array( $p->efFieldsOrder ) && isset( $p->efFieldsOrder[$i] ) ) {
							$s = $p->efFieldsOrder[$i];
						}
						else {
							if( is_array( $p->efFieldsOrder ) && !empty( $p->efFieldsOrder ) ) {
								$s = "dnu";
							}
							else {
								$s = $fields[$i];
							}
						}
						echo "<b>[</b>&nbsp;{$c}&nbsp;";
						echo sobiHTML::selectList( $o, "SBPffield[{$i}]", '' , 'value', 'text', $s );
						echo "<b>&nbsp;]&nbsp;&nbsp;";
						echo $p->eSep;
						echo "&nbsp;</b>&nbsp;<br/>";
					}
				?>
				</td>
				</tr>
				</table>
				</td>
		    </tr>
		</table>
		<?php
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 */
	function importFieldsOpt( &$p )
	{
		$fields = backupRestore_engine::getFieldRows();
		$o = array();
		$o[] = sobiHTML::makeOption( "dnu", $p->txt( "field_do_no_use_option" ) );
		$o[] = sobiHTML::makeOption( "empty", $p->txt( "field_skip_option" ) );
		for( $i = 0; $i < count( $fields ); $i++ ) {
			$o[] = sobiHTML::makeOption( $fields[$i], $fields[$i] );
		}
		?>
		<table class="SobiAdminForm" width="100%">
		  	<tr class="row1">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "import_fields_configuration_settings" ); ?></th>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left; width: 200px;">
					<?php echo $p->txt( "import_fields_values_separator" ); ?>
				</td>
				<td style="text-align:left; width: 150px;">
					<input type="text" class="text_area" name="SBPifSep" style="text-align:center" value="<?php echo $p->ifSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "import_fields_values_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "import_fields_multivalues_separator" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPifMValSep" style="text-align:center" value="<?php echo $p->ifMValSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "fields_import_multivalues_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "field_import_ignore_first_line" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPifIgnoreFirstLine', 'class="text_area"', $p->ifIgnoreFirstLine );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "field_import_ignore_first_line_expl" ); ?>
				</td>
		    </tr>		  	<tr class="row0">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "import_set_the_fields_order_for_the_csv_file" ); ?></th>
		    </tr>
		    <tr class="row1">
				<td colspan="3" style="text-align:left;">
					<?php echo $p->txt( "import_set_the_fields_order_for_the_csv_file_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td colspan="3" style="text-align:left;">
				<table class="SobiAdminForm" width="600">
				<tr>
				<td>
				<?php
					$fc = count( $fields );
					$cr = ceil( $fc / 3 );
					for( $i = 0; $i < $fc; $i++ ) {
						if( $i%$cr == 0 ) {
							echo "</td><td>";
						}
						$c = sprintf( "%02d", ( $i + 1 ) );
						if( is_array( $p->ifFieldsOrder ) && isset( $p->ifFieldsOrder[$i] ) ) {
							$s = $p->ifFieldsOrder[$i];
						}
						else {
							if( is_array( $p->ifFieldsOrder ) && !empty( $p->ifFieldsOrder ) ) {
								$s = "dnu";
							}
							else {
								$s = $fields[$i];
							}
						}
						echo "<b>[</b>&nbsp;{$c}&nbsp;";
						echo sobiHTML::selectList( $o, "SBPffield[{$i}]", '' , 'value', 'text', $s );
						echo "<b>&nbsp;]&nbsp;&nbsp;";
						echo $p->eSep;
						echo "&nbsp;</b>&nbsp;<br/>";
					}
				?>
				</td>
				</tr>
				</table>
				</td>
		    </tr>
		</table>
		<?php
	}
	function getConfigFields()
	{
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 */
	function importOpt( &$p )
	{
		$o = array(
			sobiHTML::makeOption( "0", 			$p->txt( "select" ) ),
			sobiHTML::makeOption( "entries", 	$p->txt( "select_entries_import_options" ) ),
			sobiHTML::makeOption( "cats", 		$p->txt( "select_categories_import_options" ) ),
			sobiHTML::makeOption( "fields", 	$p->txt( "select_fields_import_options" ) ),
			sobiHTML::makeOption( "config", 	$p->txt( "select_config_import_options" ) )
		);
		$select = sobiHTML::selectList( $o, "fl_ordering", 'onchange="SBPselectOption( \'import\', this.options[this.selectedIndex].value )" size="1" class="text_area" id="importSelectBox"' , 'value', 'text' );
		?>
	 	<table class="adminform" width="100%" border="1">
			<tr class="row1">
				<td>
					<?php echo $p->txt( "please_select_import_options_to_configure"); ?>
					&nbsp;
					<?php echo $select; ?>
					<input type="button" id="SBPImOptBt" class="button" value="<?php echo $p->txt( "save_settings"); ?>" onclick="SBPsaveOption('import')" align="right"/>
					<span id="importLoaderCont"></span>
				</td>
			</tr>
			<tr class="row0">
				<td height="500" valign="top">
					<div id="SBPimportOptCont"></div>
				</td>
			</tr>
		</table>
		<?php
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 */
	function importConfigOpt( &$p )
	{
		?>
		<table class="SobiAdminForm" width="100%">
		  	<tr class="row1">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "import_config_configuration_settings" ); ?></th>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;  width: 250px;">
					<?php echo $p->txt( "config_import_sobi_configuration_keys" ); ?>
				</td>
				<td style="text-align:left;  width: 150px;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPisExportConfigKeys', 'class="text_area"', $p->isExportConfigKeys );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_import_sobi_configuration_keys_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "config_import_sobi_registry" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPisExportReg', 'class="text_area"', $p->isExportReg );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_import_sobi_registry_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "config_import_sobi_templates" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPisExportTpls', 'class="text_area"', $p->isExportTpls );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_import_sobi_templates_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "config_import_sobi_css" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPisExportCSS', 'class="text_area"', $p->isExportCSS );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_import_sobi_css_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "config_import_sobi_custom_functions" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPisExportCustomFunction', 'class="text_area"', $p->isExportCustomFunction );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "config_import_sobi_custom_functions_expl" ); ?>
				</td>
		    </tr>
		</table>
		<?php
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 */
	function importCatOpt( &$p )
	{
		$rows = backupRestore_engine::getCatRows();
		$o = array();
		$o[] = sobiHTML::makeOption( "dnu", $p->txt( "field_do_no_use_option" ) );
		$o[] = sobiHTML::makeOption( "skip", $p->txt( "field_skip_option" ) );
		for( $i = 0; $i < count( $rows ); $i++ ) {
			$o[] = sobiHTML::makeOption( $rows[$i], $rows[$i] );
		}
		?>
		<table class="SobiAdminForm" width="100%">
		  	<tr class="row1">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "import_categories_configuration_settings" ); ?></th>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;  width: 250px;">
					<?php echo $p->txt( "import_categories_values_separator" ); ?>
				</td>
				<td style="text-align:left;  width: 150px;">
					<input type="text" class="text_area" name="SBPicSep" style="text-align:center" value="<?php echo $p->icSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "import_categories_values_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "import_categories_loop_limit" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPicLim" style="text-align:center" value="<?php echo $p->icLim; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "import_categories_loop_limit_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "import_categories_discharging_pause" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPicPause" style="text-align:center" value="<?php echo $p->icPause; ?>" size="5" maxlength="5"/>
					<?php echo $p->txt( "seconds" ); ?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "import_categories_discharging_pause_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "import_categories_images_too" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPicImg', 'class="text_area"', $p->icImg );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "import_categories_images_too_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "categories_import_ignore_first_line" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPicIgnoreFirstLine', 'class="text_area"', $p->icIgnoreFirstLine );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "categorie_import_ignore_first_line_expl" ); ?>
				</td>
		    </tr>
		  	<tr class="row0">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "import_categories_set_the_fields_order_for_the_csv_file" ); ?></th>
		    </tr>

		    <tr class="row1">
				<td colspan="3" style="text-align:left;">
					<?php echo $p->txt( "import_categories_set_the_fields_order_for_the_csv_file_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td colspan="3" style="text-align:left;">
				<table class="SobiAdminForm" width="600">
				<tr>
				<td>
				<?php
					$fc = count( $rows );
					$cr = ceil( $fc / 3 );
					for( $i = 0; $i < $fc; $i++ ) {
						if( $i%$cr == 0 ) {
							echo "</td><td>";
						}
						$c = sprintf( "%02d", ( $i + 1 ) );
						if( is_array( $p->icFieldsOrder ) && isset( $p->icFieldsOrder[$i] ) ) {
							$s = $p->icFieldsOrder[$i];
						}
						else {
							if( is_array( $p->icFieldsOrder ) && !empty( $p->icFieldsOrder ) ) {
								$s = "dnu";
							}
							else {
								$s = $rows[$i];
							}
						}
						echo "<b>[</b>&nbsp;{$c}&nbsp;";
						echo sobiHTML::selectList( $o, "SBPicfield[{$i}]", '' , 'value', 'text', $s );
						echo "<b>&nbsp;]&nbsp;&nbsp;";
						echo $p->ecSep;
						echo "&nbsp;</b>&nbsp;<br/>";
					}
				?>
				</td>
				</tr>
				</table>
				</td>
		    </tr>
		</table>
		<?php
	}
	/**
	 * @param sobi_backupRestore_adm $p
	 * @param array $fields
	 */
	function importEntriesOpt( &$p, $fields )
	{
		$o = array();
		$o[] = sobiHTML::makeOption( "dnu", $p->txt( "field_do_no_use_option" ) );
		$o[] = sobiHTML::makeOption( "skip", $p->txt( "field_skip_option" ) );
		for( $i = 0; $i < count( $fields ); $i++ ) {
			$o[] = sobiHTML::makeOption( $fields[$i], $fields[$i] );
		}
		?>
		<table class="SobiAdminForm" width="100%">
		  	<tr class="row1">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "import_entries_configuration_settings" ); ?></th>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left; width: 200px;">
					<?php echo $p->txt( "entry_import_values_separator" ); ?>
				</td>
				<td style="text-align:left; width: 150px;">
					<input type="text" class="text_area" name="SBPieSep" style="text-align:center" value="<?php echo $p->ieSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_values_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_categories_separator" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPieCatSep" style="text-align:center" value="<?php echo $p->ieCatSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_categories_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_multivalues_separator" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPieMValSep" style="text-align:center" value="<?php echo $p->ieMValSep; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_multivalues_separator_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_loop_limit" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPieLim" style="text-align:center" value="<?php echo $p->ieLim; ?>" size="5" maxlength="5"/>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_loop_limit_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_discharging_pause" ); ?>
				</td>
				<td style="text-align:left;">
					<input type="text" class="text_area" name="SBPiePause" style="text-align:center" value="<?php echo $p->iePause; ?>" size="5" maxlength="5"/>
					<?php echo $p->txt( "seconds" ); ?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_discharging_pause_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row1">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_images_too" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPieImg', 'class="text_area"', $p->ieImg );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_images_too_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_ignore_first_line" ); ?>
				</td>
				<td style="text-align:left;">
					<?php
						echo sobiHTML::yesnoRadioList( 'SBPieIgnoreFirstLine', 'class="text_area"', $p->ieIgnoreFirstLine );
					?>
				</td>
				<td style="text-align:left;">
					<?php echo $p->txt( "entry_import_ignore_first_line_expl" ); ?>
				</td>
		    </tr>
		  	<tr class="row1">
				<th colspan="3" style="text-align:left;"><?php echo $p->txt( "set_the_fields_order_of_the_csv_file" ); ?></th>
		    </tr>
		    <tr class="row0">
				<td colspan="3" style="text-align:left;">
					<?php echo $p->txt( "set_the_fields_order_of_the_csv_file_expl" ); ?>
				</td>
		    </tr>
		    <tr class="row0">
				<td colspan="3" style="text-align:left;">
				<table class="SobiAdminForm" width="600">
				<tr>
				<td>
				<?php
					$fc = count( $fields );
					$cr = ceil( $fc / 3 );
					for( $i = 0; $i < $fc; $i++ ) {
						if( $i%$cr == 0 ) {
							echo "</td><td>";
						}
						$c = sprintf( "%02d", ( $i + 1 ) );
						if( is_array( $p->ieFieldsOrder ) && isset( $p->ieFieldsOrder[$i] ) ) {
							$s = $p->ieFieldsOrder[$i];
						}
						else {
							if( is_array( $p->ieFieldsOrder ) && !empty( $p->ieFieldsOrder) ) {
								$s = "dnu";
							}
							else {
								$s = $fields[$i];
							}
						}
						echo "<b>[</b>&nbsp;{$c}&nbsp;";
						echo sobiHTML::selectList( $o, "SBPiEfield[{$i}]", '' , 'value', 'text', $s );
						echo "<b>&nbsp;]&nbsp;&nbsp;";
						echo $p->ieSep;
						echo "&nbsp;</b>&nbsp;<br/>";
					}
				?>
				</td>
				</tr>
				</table>
				</td>
		    </tr>
		</table>
		<?php
	}
	/**
	 * Enter description here...
	 *
	 * @param sobi_backupRestore_adm $p
	 */
	function entriesExportFinishScreen( &$p, $msg, $sid )
	{
//		$href = "index3.php?option=com_sobi2&task=export_download_package&file=sobi2_entries_export&SBPSes={$sid}";
		$config =& sobi2Config::getInstance();
		$href = "{$config->liveSite}/{$p->_baseDir}/sobibackup/{$sid}/sobi2_entries_export.zip";
		$config =& sobi2Config::getInstance();
		$img = "{$config->liveSite}/administrator/components/com_sobi2/plugins/backup/download.png";
		?>
		<br/>
		<div style="width: 350px; text-align:center;">
			<?php echo $msg;?>
			<br/>
			<a href="<?php echo $href;?>">
				<img src="<?php echo $img;?>" alt="download" border="0"/>
			</a>
			<br/>
			<a href="<?php echo $href;?>">
				<?php echo $p->txt( "download_entries_package_file" ); ?>
			</a>
		</div>
		<?php
	}
	/**
	 * Enter description here...
	 *
	 * @param sobi_backupRestore_adm $p
	 */
	function configExportFinishScreen( &$p, $msg, $sid )
	{
		$config =& sobi2Config::getInstance();
		$href = "{$config->liveSite}/{$p->_baseDir}/sobibackup/{$sid}/sobi2_config_export.zip";
		$config =& sobi2Config::getInstance();
		$img = "{$config->liveSite}/administrator/components/com_sobi2/plugins/backup/download.png";
		?>
		<br/>
		<div style="width: 350px; text-align:center;">
			<?php echo $msg;?>
			<br/>
			<a href="<?php echo $href;?>">
				<img src="<?php echo $img;?>" alt="download" border="0"/>
			</a>
			<br/>
			<a href="<?php echo $href;?>">
				<?php echo $p->txt( "download_config_package_file" ); ?>
			</a>
		</div>
		<?php
	}

	/**
	 * Enter description here...
	 *
	 * @param sobi_backupRestore_adm $p
	 */
	function catsExportFinishScreen( &$p, $msg, $sid )
	{
//		$href = "index3.php?option=com_sobi2&task=export_download_package&file=sobi2_categories_export&SBPSes={$sid}";
		$config =& sobi2Config::getInstance();
		$href = "{$config->liveSite}/{$p->_baseDir}/sobibackup/{$sid}/sobi2_categories_export.zip";
		$config =& sobi2Config::getInstance();
		$img = "{$config->liveSite}/administrator/components/com_sobi2/plugins/backup/download.png";
		?>
		<br/>
		<div style="width: 350px; text-align:center;">
			<?php echo $msg;?>
			<br/>
			<a href="<?php echo $href;?>">
				<img src="<?php echo $img;?>" alt="download" border="0"/>
			</a>
			<br/>
			<a href="<?php echo $href;?>">
				<?php echo $p->txt( "download_categories_package_file" ); ?>
			</a>
		</div>
		<?php
	}
	/**
	 * Enter description here...
	 *
	 * @param sobi_backupRestore_adm $p
	 */
	function fieldsExportFinishScreen( &$p, $msg, $sid )
	{
//		$href = "index3.php?option=com_sobi2&task=export_download_package&file=sobi2_entries_export&SBPSes={$sid}";
		$config =& sobi2Config::getInstance();
		$href = "{$config->liveSite}/{$p->_baseDir}/sobibackup/{$sid}/sobi2_fields_export.zip";
		$config =& sobi2Config::getInstance();
		$img = "{$config->liveSite}/administrator/components/com_sobi2/plugins/backup/download.png";
		?>
		<br/>
		<div style="width: 350px; text-align:center;">
			<?php echo $msg;?>
			<br/>
			<a href="<?php echo $href;?>">
				<img src="<?php echo $img;?>" alt="download" border="0"/>
			</a>
			<br/>
			<a href="<?php echo $href;?>">
				<?php echo $p->txt( "download_fields_package_file" ); ?>
			</a>
		</div>
		<?php
	}
	/**
	 * Enter description here...
	 *
	 * @param sobi_backupRestore_adm $p
	 */
	function uploadField( $name, $label, $sid, $task, $expl, $warning, $msg )
	{
		?>
		<form action="index3.php" method="post" id="importform" name="adminForm" enctype="multipart/form-data">
		<br/>
			<div>
				<div style="float:left;"><?php echo $expl; ?>&nbsp;</div>
				<div style="float:left;"><input type="file" name="<?php echo $name; ?>" size="30" class="text_area" style="float:left;" />&nbsp;</div>
			</div>
			<input type="hidden" name="option" value="com_sobi2" />
			<input type="hidden" name="SBPSis" value="<?php echo $sid; ?>" />
			<input type="hidden" name="task" value="<?php echo $task; ?>" />
			<input type="hidden" name="sbpfu" value="1" />
			<br/><br/>
			<div style="float:left;"><input type="submit" class="text_area" onclick="
				if( confirm('<?php echo $warning; ?>') ) {
					alert('<?php echo $msg; ?>');
					document.getElementById('importform').submit();
				}
				else {
					return false;
				}
			" value="<?php echo $label; ?>"/>&nbsp;</div>
		</form>
		<?php
	}
}
?>