<?php
/**
 * @package Sigsiu Online Business Index 2
 * @subpackage Backup Restore Plugin
 * ===================================================
 * @copyright Copyright (C) 2007 Sigsiu.NET (http://www.sigsiu.net). All rights
 * reserved.
 * @license This plugin is released under Proprietary Commercial License. You may
 * use this extension on one SOBI2 installation only. To use it on more sites, you
 * need to buy extra license  for each. You may not resell, distribute or publish
 * this extension or parts (code snippets) of it.
 * @author Name: Sigrid & Radek Suski, Sigsiu.NET
 * Email: sobi@sigsiu.net
 * Url: http://www.sigsiu.net
 * ===================================================
 * @version $Id: sobi_backupRestore_adm.php 4512 2008-10-06 12:06:01Z Radek Suski $
 * @updated 17-Mar-2008 5:27:22 PM
 */
defined( "_SOBI2_" )  || ( trigger_error( "Restricted access", E_USER_ERROR ) && exit() );
define( "__SBRP_BASE_DIR", "media" );
define( "__SBRP_BASE_ZIP_BITNUM", 32 );
define( "__SBRP_BASE_ZIP_CODE", "code" );
define( "__SBRP_BASE_ZPL", "PLACE" );
class sobi_backupRestore_adm
{
	/**
	 * @var int
	 */
	var $orderId = 0;
	/**
	 * @var string
	 */
	var $orderMail = "";
	/**
	 * @var array
	 */
	var $_language = array();
	/**
	 * @var string
	 */
	var $name_id = "backup";
	/**
	 * @var string
	 */
	var $name = "Import and Backup";
	/**
	 * @var backupRestore_engine
	 */
	var $_engine;
	/**
	 * @var array
	 */
	var $_config;
	/**
	 * @var string
	 */
	var $_baseDir = "media";
	/**
	 * @var bool
	 */
	var $iBackTbls = false;
	/**
	 * @var string
	 */
	var $eSep = ";";
	/**
	 * @var string
	 */
	var $eCatSep = ",";
	/**
	 * @var string
	 */
	var $eMValSep = ",";
	/**
	 * @var int
	 */
	var $eLim = 150;
	/**
	 * @var bool
	 */
	var $eImg = true;
	/**
	 * @var bool
	 */
	var $eFilterHtml = true;
	/**
	 * @var bool
	 */
	var $eInit = false;
	/**
	 * @var bool
	 */
	var $eFilterSep = true;
	/**
	 * @var int
	 */
	var $ePause = 10;
	/**
	 * @var array
	 */
	var $eFieldsOrder = array();
	/**
	 * @var string
	 */
	var $ieSep = ";";
	/**
	 * @var string
	 */
	var $ieCatSep = ",";
	/**
	 * @var string
	 */
	var $ieMValSep = ",";
	/**
	 * @var int
	 */
	var $ieLim = 150;
	/**
	 * @var bool
	 */
	var $ieImg = true;
	/**
	 * @var bool
	 */
	var $ieInit = false;
	/**
	 * @var bool
	 */
	var $ieIgnoreFirstLine = false;
	/**
	 * @var int
	 */
	var $iePause = 10;
	/**
	 * @var array
	 */
	var $ieFieldsOrder = array();
	/**
	 * @var string
	 */
	var $ecSep = ";";
	/**
	 * @var int
	 */
	var $ecLim = 150;
	/**
	 * @var bool
	 */
	var $ecImg = true;
	/**
	 * @var bool
	 */
	var $ecFilterHtml = true;
	/**
	 * @var bool
	 */
	var $ecInit = false;
	/**
	 * @var bool
	 */
	var $ecFilterSep = true;
	/**
	 * @var int
	 */
	var $ecPause = 10;
	/**
	 * @var array
	 */
	var $ecFieldsOrder = array();
	/**
	 * @var string
	 */
	var $icSep = ";";
	/**
	 * @var int
	 */
	var $icLim = 150;
	/**
	 * @var bool
	 */
	var $icImg = true;
	/**
	 * @var bool
	 */
	var $icInit = false;
	/**
	 * @var bool
	 */
	var $icIgnoreFirstLine = true;
	/**
	 * @var int
	 */
	var $icPause = 10;
	/**
	 * @var array
	 */
	var $icFieldsOrder = array();
	/**
	 * @var string
	 */
	var $efSep = ";";
	/**
	 * @var string
	 */
	var $efMValSep = ",";
	/**
	 * @var bool
	 */
	var $efInit = false;
	/**
	 * @var bool
	 */
	var $efFilterSep = true;
	/**
	 * @var array
	 */
	var $efFieldsOrder = array();
	/**
	 * @var string
	 */
	var $ifSep = ";";
	/**
	 * @var string
	 */
	var $ifMValSep = ",";
	/**
	 * @var bool
	 */
	var $ifInit = false;
	/**
	 * @var array
	 */
	var $ifFieldsOrder = array();
	/**
	 * @var bool
	 */
	var $ifIgnoreFirstLine = false;
	/**
	 * @var bool
	 */
	var $esExportConfigKeys = true;
	/**
	 * @var bool
	 */
	var $esExportTpls = true;
	/**
	 * @var bool
	 */
	var $esExportCSS = true;
	/**
	 * @var bool
	 */
	var $esExportReg = true;
	/**
	 * @var bool
	 */
	var $esExportCustomFunction = false;
	/**
	 * @var bool
	 */
	var $isExportConfigKeys = true;
	/**
	 * @var bool
	 */
	var $isExportTpls = true;
	/**
	 * @var bool
	 */
	var $isExportCSS = true;
	/**
	 * @var bool
	 */
	var $isExportReg = true;
	/**
	 * @var bool
	 */
	var $isImportReg = "NzgwOTI4MTgxNTc=";
	/**
	 * @var bool
	 */
	var $isExportCustomFunction = false;
	/**
	 * Enter description here...
	 *
	 * @return sobi_backupRestore_adm
	 */
	function sobi_backupRestore_adm()
	{
		$config =& sobi2Config::getInstance();
		if( !$lang = sobi2Config::translatePath( "plugins|backup|{$config->sobi2Language}", "adm", true, ".ini" ) ) {
			$lang = sobi2Config::translatePath( "plugins|backup|english", "adm", true, ".ini" );
		}
		$this->_language = parse_ini_file( $lang );
		$this->_baseDir = __SBRP_BASE_DIR;
	}

	/**
	 * Enter description here...
	 *
	 */
	function init( $f = true )
	{
		$config =& sobi2Config::getInstance();
		$db =& $config->getDb();
		$db->setQuery( "SELECT * FROM #__sobi2_plugin_backup_config ");
		$c = $db->loadObjectList();
		if ( $db->getErrorNum() ) {
			trigger_error( "DB reports: ".$db->stderr(), E_USER_WARNING );
		}
		foreach ( $c as $r ) {
			$k = trim( (string) $r->configKey );
			if( isset( $this->$k ) ) {
				$this->$k = $r->configValue;
			}
		}
		if( $f ) {
			sobi2Config::import( "plugins|backup|backupRestore_settings", "adm" );
			sobi_backupRestore_settings::initOrder( $this );
		}
	}
	function lastTablesBackup()
	{
		$config =& sobi2Config::getInstance();
		$db =& $config->getDb();
		$db->setQuery( "SHOW TABLE STATUS LIKE 'backup_%_sobi2_cats_relations'" );
		$ctime = null;
		if( !$config->forceLegacy && class_exists( "JDatabase" ) ) {
			$ctime = $db->loadObject();
		}
    	else {
    		$db->loadObject( $ctime );
    	}
		if ( $db->getErrorNum() ) {
			trigger_error( "DB reports: ".$db->stderr(), E_USER_WARNING );
		}
		return isset( $ctime->Create_time ) ? $ctime->Create_time : $this->txt( "never" );
	}
	/**
	 * Enter description here...
	 *
	 */
	function config()
	{
		$this->init( false );
		if( sobi2Config::translatePath( "plugins|backup|backupRestore_engine", "adm", true ) && sobi2Config::translatePath( "plugins|backup|backupRestore_settings", "adm", true ) ) {
			sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
			backupRestore_html::config( $this );
		}
		else {
			sobi2Config::import( "plugins|backup|register", "adm" );
			sobi_backupRestoreRegister( $this );
		}
	}
	/**
	 *
	 * @param string task
	 */
	function customTask( $task )
	{
		$r = false;
		switch ( $task ) {
			case "load_entries_export_screen":
				$r = true;
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				backupRestore_html::exportEntriesOpt( $this, $this->getEntriesFields() );
				break;

			case "save_entries_export":
				$r = true;
				$this->init();
				sobi_backupRestore_settings::saveEntriesExportConfig( $this );
				break;

			case "start_entries_export":
				$r = true;
				$this->init();
				$session = sobi2Config::request( $_REQUEST, "SBPSes", 0 );
				if( !$session ) {
					if( !$this->eInit ) {
						echo $this->txt( "please_configure_entries_export_options_first" );
						return $r;
					}
				}
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				$engine = new backupRestore_engine( "entries", "export" );
				$engine->exportEntries( $session, $this );
				break;

			case "entries_export_finish_screen":
				$r = true;
				$session = sobi2Config::request( $_REQUEST, "SBPSes", 0 );
				$msg = sobi2Config::request( $_REQUEST, "msg", null );
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				backupRestore_html::entriesExportFinishScreen( $this, $msg, $session );
				break;

			case "export_download_package":
				$r = true;
				$session = sobi2Config::request( $_REQUEST, "SBPSes", 0 );
				$file = sobi2Config::request( $_REQUEST, "file", 0 );
				$backupFile["path"] = sobi2Config::translatePath( "{$this->_baseDir}|sobibackup|{$session}|{$file}", "root", false, ".zip" );
				$backupFile["name"] = "{$file}.zip";
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				backupRestore_engine::sendPackage( $backupFile );
				break;

			case "load_cats_export_screen":
				$r = true;
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				backupRestore_html::exportCatOpt( $this );
				break;

			case "save_cats_export":
				$r = true;
				$this->init();
				sobi_backupRestore_settings::saveCatsExportConfig( $this );
				break;

			case "start_cats_export":
				$r = true;
				$this->init();
				$session = sobi2Config::request( $_REQUEST, "SBPSes", 0 );
				if( !$session ) {
					if( !$this->ecInit ) {
						echo $this->txt( "please_configure_categories_export_options_first" );
						return $r;
					}
				}
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				$engine = new backupRestore_engine( "categories", "export" );
				$engine->exportCats( $session, $this );
				break;

			case "categories_export_finish_screen":
				$r = true;
				$session = sobi2Config::request( $_REQUEST, "SBPSes", 0 );
				$msg = sobi2Config::request( $_REQUEST, "msg", null );
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				backupRestore_html::catsExportFinishScreen( $this, $msg, $session );
				break;

			case "load_fields_export_screen":
				$r = true;
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				sobi2Config::import( "admin.field.class", "adm" );
				backupRestore_html::exportFieldsOpt( $this );
				break;

			case "load_config_export_screen":
				$r = true;
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				backupRestore_html::exportConfigOpt( $this );
				break;

			case "load_entries_import_screen":
				$r = true;
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				backupRestore_html::importEntriesOpt( $this, $this->getEntriesFields() );
				break;

			case "save_entries_import":
				$r = true;
				$this->init();
				sobi_backupRestore_settings::saveEntriesImportConfig( $this );
				break;

			case "start_entries_import":
				$r = true;
				$this->init();
				$session = sobi2Config::request( $_REQUEST, "SBPSis", 0 );
				if( !$session ) {
					if( !$this->ieInit ) {
						echo $this->txt( "please_configure_entries_import_options_first" );
						return $r;
					}
				}
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				$engine = new backupRestore_engine( "entries", "import" );
				$engine->importEntries( $session, $this );
				break;

			case "load_cats_import_screen":
				$r = true;
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				backupRestore_html::importCatOpt( $this );
				break;

			case "save_cats_import":
				$r = true;
				$this->init();
				sobi_backupRestore_settings::saveCatsImportConfig( $this );
				break;

			case "start_cats_import":
				$r = true;
				$this->init();
				$session = sobi2Config::request( $_REQUEST, "SBPSis", 0 );
				if( !$session ) {
					if( !$this->icInit ) {
						echo $this->txt( "please_configure_categories_import_options_first" );
						return $r;
					}
				}
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				$engine = new backupRestore_engine( "categories", "import" );
				$engine->importCats( $session, $this );
				break;

			case "cats_import_finish_screen":
				$r = true;
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				$session = sobi2Config::request( $_REQUEST, "SBPSis", 0 );
				$msg = array();
				$config =& sobi2Config::getInstance();
				$msg[] = sobi2Config::request( $_REQUEST, "msg", null );
				$msg[] = "<br/><a href=\"{$config->liveSite}/{$this->_baseDir}/sobibackup/{$session}/logfile.txt\">";
				$msg[] = $this->txt( "cats_import_finish_screen_see_logfile" );
				$msg[] = "</a>";
				backupRestore_html::summaryScreen( $this->txt( "categories_import_summary_screen"), $msg );
				break;

			case "entries_import_finish_screen":
				$r = true;
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				$session = sobi2Config::request( $_REQUEST, "SBPSis", 0 );
				$msg = array();
				$config =& sobi2Config::getInstance();
				$msg[] = sobi2Config::request( $_REQUEST, "msg", null );
				$msg[] = "<br/><a href=\"{$config->liveSite}/{$this->_baseDir}/sobibackup/{$session}/logfile.txt\">";
				$msg[] = $this->txt( "entries_import_finish_screen_see_logfile" );
				$msg[] = "</a>";
				backupRestore_html::summaryScreen( $this->txt( "entries_import_finished"), $msg );
				break;

			case "save_fields_export":
				$r = true;
				$this->init();
				sobi_backupRestore_settings::saveFieldsExportConfig( $this );
				break;

			case "start_fields_export":
				$r = true;
				$session = time();
				$this->init();
				if( !$this->efInit ) {
					echo $this->txt( "please_configure_fields_export_options_first" );
					return $r;
				}
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				sobi2Config::import( "admin.field.class", "adm" );
				$engine = new backupRestore_engine( "fields", "export" );
				$engine->exportFields( $session, $this );
				break;

			case "fields_export_finish_screen":
				$r = true;
				$session = sobi2Config::request( $_REQUEST, "SBPSes", 0 );
				$msg = sobi2Config::request( $_REQUEST, "msg", null );
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				backupRestore_html::fieldsExportFinishScreen( $this, $msg, $session );
				break;

			case "load_fields_import_screen":
				$r = true;
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				sobi2Config::import( "admin.field.class", "adm" );
				backupRestore_html::importFieldsOpt( $this );
				break;

			case "save_fields_import":
				$r = true;
				$this->init();
				sobi_backupRestore_settings::saveFieldsImportConfig( $this );
				break;

			case "start_fields_import":
				$r = true;
				$session = sobi2Config::request( $_REQUEST, "SBPSis", 0 );
				$this->init();
				if( !$session ) {
					if( !$this->ifInit ) {
						echo $this->txt( "please_configure_fields_export_options_first" );
						return $r;
					}
				}
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				$engine = new backupRestore_engine( "fields", "import" );
				$engine->importFields( $session, $this );
				break;

			case "fields_import_finish_screen":
				$r = true;
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				$session = sobi2Config::request( $_REQUEST, "SBPSis", 0 );
				$msg = array();
				$config =& sobi2Config::getInstance();
				$msg[] = sobi2Config::request( $_REQUEST, "msg", null );
				$msg[] = "<br/><a href=\"{$config->liveSite}/{$this->_baseDir}/sobibackup/{$session}/logfile.txt\">";
				$msg[] = $this->txt( "fields_import_finish_screen_see_logfile" );
				$msg[] = "</a>";
				backupRestore_html::summaryScreen( $this->txt( "fields_import_finished"), $msg );
				break;

			case "br_clone_entries_i_to_e":
			case "br_clone_cats_i_to_e":
			case "br_clone_fields_i_to_e":
			case "br_clone_entries_e_to_i":
			case "br_clone_cats_e_to_i":
			case "br_clone_fields_e_to_i":
				$r = true;
				$this->init();
				sobi_backupRestore_settings::cloneConfig( $task, $this );
				sobi2Config::redirect( "index2.php?option=com_sobi2&task=plugins&S2_plugin=backup", $this->txt( "url_msg_settings_cloned" ) );
				break;

			case "br_restore_tables":
				$r = true;
				sobi2Config::import( "plugins|backup|backupRestore_settings", "adm" );
				sobi_backupRestore_settings::restoreTables( $this );
				sobi2Config::redirect( "index2.php?option=com_sobi2&task=plugins&S2_plugin=backup", $this->txt( "url_msg_tables_restored" ) );
				break;

			case "br_backup_tables":
				$r = true;
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				backupRestore_engine::backupTables( false );
				sobi2Config::redirect( "index2.php?option=com_sobi2&task=plugins&S2_plugin=backup", $this->txt( "url_msg_tables_created" ) );
				break;

			case "save_config_export":
				$r = true;
				$this->init();
				sobi_backupRestore_settings::saveConfigExportConfig( $this );
				break;

			case "start_config_export":
				$r = true;
				$session = time();
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				$engine = new backupRestore_engine( "config", "export" );
				$engine->exportConfig( $session, $this );
				break;

			case "config_export_finish_screen":
				$r = true;
				$session = sobi2Config::request( $_REQUEST, "SBPSes", 0 );
				$msg = sobi2Config::request( $_REQUEST, "msg", null );
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				backupRestore_html::configExportFinishScreen( $this, $msg, $session );
				break;

			case "load_config_import_screen":
				$r = true;
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				sobi2Config::import( "admin.field.class", "adm" );
				backupRestore_html::importConfigOpt( $this );
				break;

			case "start_config_import":
				$r = true;
				$session = sobi2Config::request( $_REQUEST, "SBPSis", 0 );
				$this->init();
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
				$engine = new backupRestore_engine( "config", "import" );
				$engine->importConfig( $session, $this );
				break;

			case "save_config_import":
				$r = true;
				$this->init();
				sobi_backupRestore_settings::saveConfigImportConfig( $this );
				break;

			case "config_import_finish_screen":
				$r = true;
				sobi2Config::import( "plugins|backup|backupRestore_html", "adm" );
				$session = sobi2Config::request( $_REQUEST, "SBPSis", 0 );
				$msg = array();
				$config =& sobi2Config::getInstance();
				$msg[] = sobi2Config::request( $_REQUEST, "msg", null );
				$msg[] = "<br/><a href=\"{$config->liveSite}/{$this->_baseDir}/sobibackup/{$session}/logfile.txt\">";
				$msg[] = $this->txt( "config_import_finish_screen_see_logfile" );
				$msg[] = "</a>";
				backupRestore_html::summaryScreen( $this->txt( "config_import_finished"), $msg );
				break;

			case "sbrpSendReg":
				sobi2Config::import( "plugins|backup|register", "adm" );
				sbrpSendReg();
				$r = true;
				break;

		}
		return $r;
	}
	/**
	 * Enter description here...
	 *
	 * @return array
	 */
	function getEntriesFields()
	{
		sobi2Config::import( "plugins|backup|backupRestore_engine", "adm" );
		return backupRestore_engine::getEntriesFields();
	}
	/**
	 *
	 * @param string $txt
	 * @return string
	 */
	function txt( $txt ) { return ( isset( $this->_language[$txt] ) && $this->_language[$txt] ) ? $this->_language[$txt] : $txt; }
	function saveEntriesExportConfig() { sobi_backupRestore_settings::saveEntriesExportConfig( $this ); }
	function saveCatsExportConfig() { sobi_backupRestore_settings::saveCatsExportConfig( $this ); }
	function saveEntriesImportConfig() { sobi_backupRestore_settings::saveEntriesImportConfig( $this ); }
	function saveCatsImportConfig() { sobi_backupRestore_settings::saveCatsImportConfig( $this ); }
	function saveFieldsImportConfig() { sobi_backupRestore_settings::saveFieldsImportConfig( $this ); }
}
?>