<?php
/**
* @version 2.0
* @package DJ Catalog
* @subpackage DJ Catalog Component
* @copyright Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.
* @license http://www.gnu.org/licenses GNU/GPL
* @author url: http://design-joomla.eu
* @author email contact@design-joomla.eu
* @developer Michal Olczyk - michal.olczyk@design-joomla.eu
*
*
* DJ Catalog is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* DJ Catalog is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with DJ Catalog. If not, see <http://www.gnu.org/licenses/>.
*
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.helper');

class DJCatalogHelperRoute
{
	function getItemRoute($id, $catid = 0)
	{
		$link = 'index.php?option=com_djcatalog&view=item&id='. $id;

		if($catid) {
			$link .= '&cid='.$catid;
		}

		if($item = DJCatalogHelperRoute::_findItem((int)$id)) {
			$link .= '&Itemid='.$item->id;
		}
		else if ($item = DJCatalogHelperRoute::_findCategory((int)$catid, 'items')) {
			$link .= '&Itemid='.$item->id;
		}
		else if ($item = DJCatalogHelperRoute::_findCategory((int)$catid, 'itemstable')) {
			$link .= '&Itemid='.$item->id;
		}

		return $link;
	}
	
	function getProducerRoute($id)
	{
		$link = 'index.php?option=com_djcatalog&view=producer&pid='. $id;

		if($item = DJCatalogHelperRoute::_findProducer((int)$id)) {
			$link .= '&Itemid='.$item->id;
		}
		
		return $link;
	}

	function getCategoryRoute($catid, $layout = 'items')
	{
		$link = 'index.php?option=com_djcatalog&view='.$layout.'&cid='.$catid;
		
		if($item = DJCatalogHelperRoute::_findCategory((int)$catid, $layout)) {
			$link .= '&Itemid='.$item->id;
		}

		return $link;
	}

	function _findItem($id)
	{
		$component =& JComponentHelper::getComponent('com_djcatalog');

		$menus	= &JApplication::getMenu('site', array());
		$items	= $menus->getItems('componentid', $component->id);

		$match = null;
		if (count($items)) {
			foreach($items as $item)
			{
				if ((@$item->query['view'] == 'item') && @$item->query['id'] == $id) {
					$match = $item;
					break;
				}
			}
		}

		return $match;
	}
	function _findProducer($id)
	{
		$component =& JComponentHelper::getComponent('com_djcatalog');

		$menus	= &JApplication::getMenu('site', array());
		$items	= $menus->getItems('componentid', $component->id);

		$match = null;
		
		if (count($items)) {
			foreach($items as $item)
			{
				if ((@$item->query['view'] == 'producer') && @$item->query['pid'] == $id) {
					$match = $item;
					break;
				}
			}
		}

		return $match;
	}
	function _findCategory($id, $layout)
	{
		$component =& JComponentHelper::getComponent('com_djcatalog');

		$menus	= &JApplication::getMenu('site', array());
		$items	= $menus->getItems('componentid', $component->id);

		$match = null;
		if (count($items)) {
			foreach($items as $item)
			{
				if ((@$item->query['view'] == $layout) && @$item->query['cid'] == $id ) {
					$match = $item;
					break;
				}
			}
		}
		return $match;
	}
}
?>
