<?php
/**
* @version 2.0
* @package DJ Catalog
* @subpackage DJ Catalog Component
* @copyright Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.
* @license http://www.gnu.org/licenses GNU/GPL
* @author url: http://design-joomla.eu
* @author email contact@design-joomla.eu
* @developer Michal Olczyk - michal.olczyk@design-joomla.eu
*
*
* DJ Catalog is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* DJ Catalog is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with DJ Catalog. If not, see <http://www.gnu.org/licenses/>.
*
*/

defined ('_JEXEC') or die('Restricted access');
?>

<?php if ($this->params->get( 'show_page_title', 1) && $this->params->get('page_title') != $this->category->name) : ?>
<div class="componentheading<?php echo $this->params->get( 'pageclass_sfx' ) ?>">
	<?php echo $this->escape($this->params->get('page_title')); ?>
</div>
<?php endif; ?>
<div id="djcatalog" class="djcatalog<?php echo $this->params->get( 'pageclass_sfx' ) ?>">
	<?php if ($this->params->get('showcatdesc') && $this->category) {?>
	<div id="djcat_blog_category">
		<div class="djcat_blog_category-in">
			<?php if ($this->category->images = $this->images->getImages($this->category->image_url)) { ?>
	        	<div class="djcat_image" style="width: <?php echo $this->params->get('th_width'); ?>px;">
					<a rel="lightbox-djcategory" title="<?php echo $this->category->name?>" href="<?php echo $this->category->images[0]['original']?>"><img alt="<?php echo $this->category->name; ?>" src="<?php echo $this->category->images[0]['medium']; ?>"/></a>
					<?php if (count($this->category->images) > 1) {?>
						<div class="djcat_thumbnails">
							<?php for($i = 1; $i < count($this->category->images); $i++) {?>
								<a rel="lightbox-<?php echo $category->name?>" title="<?php echo $category->name?>" href="<?php echo $this->category->images[$i]['original']?>"><img alt="<?php echo $this->category->name; ?>" src="<?php echo $this->category->images[$i]['small']; ?>" style="width: <?php echo ($this->params->get('smallth_width') - 4); ?>px; margin-left: 2px; margin-right: 2px;"/></a>
							<?php } ?>
						</div>
						<?php } ?>
	        	</div>
			<?php } ?>
			<div class="djcat_blog_category_title">
				<h3><?php echo $this->category->name; ?></h3>
			</div>
			<div class="djcat_blog_category_desc">
				<?php echo $this->category->description; ?>
			</div>
		</div>
	</div>
	<div class="clear"></div>
	<?php } ?>
	<?php if ($this->params->get('showsubcategories') && $this->subcategories) {?>
	<div id="djcat_blog_subcategories">
		<?php if ($this->params->get('showsubcategories_label')) { ?><h3><?php echo JText::_('COM_DJCATALOG_SUBCATEGORIES'); ?></h3><?php } ?>
		<div class="djcat_blog_subcategories_in">
			<?php foreach($this->subcategories as $subcategory) { ?>
			<div class="djcat_blog_subcategory" style="width:<?php echo (100/$this->params->get('category_columns',4)-0.1); ?>%">
				<div class="djcat_blog_subcategory_bg">
					<div class="djcat_blog_subcategory_in">
						<?php if ($subcategory->images = $this->images->getImages($subcategory->image_url)) { ?>
				        	<div class="djcat_blog_image">
								<?php if ($this->params->get('image_link_subcategory')) { ?>
									<a rel="lightbox-djsubcategory" title="<?php echo $subcategory->name?>" href="<?php echo $subcategory->images[0]['original']?>"><img alt="<?php echo $subcategory->name; ?>" src="<?php echo $subcategory->images[0]['medium']; ?>"/></a>
				        		<?php } else { ?>
				        			<a href="<?php echo JRoute::_(DJCatalogHelperRoute::getCategoryRoute($subcategory->catslug, 'itemstable'));?>"><img alt="<?php echo $subcategory->name; ?>" src="<?php echo $subcategory->images[0]['medium']; ?>"/></a>
				        		<?php } ?>
				        	</div>
						<?php } ?>
						<div class="djcat_blog_subcategory_title">
							<h3><a href="<?php echo JRoute::_(DJCatalogHelperRoute::getCategoryRoute($subcategory->catslug, 'itemstable'));?>"><?php echo $subcategory->name; ?></a></h3>
						</div>
						<?php if ($this->params->get('category_show_intro')) {?>
						<div class="djcat_blog_subcategory_desc">
							<?php if ($this->params->get('category_intro_length') > 0 ) {
									echo DJCatalogHelper::trimText($subcategory->description, $this->params->get('category_intro_length'));
								}
								else {
									echo $subcategory->description; 
								}
							?>
						</div>
						<?php } ?>
						<?php if ($this->params->get('showreadmore_subcategory')) { ?>
							<div class="clear"></div>
							<div class="djcat_subcategory_readmore">
								<a href="<?php echo JRoute::_(DJCatalogHelperRoute::getCategoryRoute($subcategory->catslug, 'itemstable')); ?>" class="readon"><?php echo JText::_('COM_DJCATALOG_BROWSE'); ?></a>
							</div>
						<?php } ?>
					</div>
				</div>
			</div>
			<?php } ?>
		</div>
	</div>
	<div class="clear"></div>
	<?php } ?>
	<?php if ($this->params->get('show_category_filter') > 0 || $this->params->get('show_producer_filter') > 0 || $this->params->get('show_search') > 0) { ?>
	<div class="djcat_toolbar" id="tlb">
		<div class="djcat_toolbar_in">
			<div class="djcat_toolbar_filter">
				<form name="djcatalogForm" id="djcatalogForm" method="get" action="index.php">
					<?php if ($this->params->get('show_category_filter') > 0 || $this->params->get('show_producer_filter') > 0) { ?>
					<ul>
						<li><span><?php echo JText::_('COM_DJCATALOG_FILTER'); ?></span></li>
						<?php if ($this->params->get('show_category_filter') > 0) { ?>
							<li><?php echo $this->lists['categories'];?></li>
						<?php } ?>
						<?php if ($this->params->get('show_producer_filter') > 0) { ?>
							<li><?php echo $this->lists['producers'];?></li>
						<?php } ?>
					</ul>
					<?php } ?>
					<?php if ($this->params->get('show_search') > 0) { ?>
						<ul>
							<li><span><?php echo JText::_('COM_DJCATALOG_SEARCH'); ?></span></li>
							<li><input type="text" name="search" id="djcatsearch" value="<?php echo $this->lists['search'];?>" /></li>
							<li><input type="submit" class="button" onclick="document.djcatalogForm.submit();" value="<?php echo JText::_( 'COM_DJCATALOG_GO' ); ?>" /></li>
							<li><input type="submit" class="button" onclick="document.getElementById('djcatsearch').value='';document.djcatalogForm.submit();" value="<?php echo JText::_( 'COM_DJCATALOG_RESET' ); ?>" /></li>
						</ul>
					<?php } ?>
				<input type="hidden" name="option" value="com_djcatalog" />
				<input type="hidden" name="view" value="itemstable" />
				<input type="hidden" name="limitstart" value="0" />
				<input type="hidden" name="order" value="<?php echo JRequest::getVar('order','i.ordering'); ?>" />
				<input type="hidden" name="dir" value="<?php echo (JRequest::getVar('dir','asc')); ?>" />
				<input type="hidden" name="Itemid" value="<?php echo JRequest::getVar('Itemid'); ?>" />
				</form>
			</div>
		</div>
	</div>
	<?php } ?>
	<div class="clear"></div>
	<?php $orderUrl = DJCatalogHelperRoute::getCategoryRoute(JRequest::getVar('cid',null,'defalut','int'), 'itemstable').'&pid='.JRequest::getVar('pid',null,'defalut','int'); ?>
    <?php if (count($this->items) < 1){
			?><p style="text-align: center;"><?php echo JText::_('COM_DJCATALOG_NO_ITEMS_FOUND');?></p><?php
		} else { ?>
		<table cellpadding="0" cellspacing="0" class="djcat_table" id="djcat_table">
            <tr class="sectiontableheader">
                <td class="djcat_th_image">&nbsp;</td>
				<td class = "djcat_th_title" nowrap="nowrap">
					<?php if ($this->params->get('show_name_orderby') > 0) { ?>
                    	<a href="<?php echo JRoute::_( $orderUrl.'&order=i.name&dir='.$this->lists['order_Dir'].'#djcat_table'); ?>"><?php echo JText::_('COM_DJCATALOG_NAME'); ?><?php echo $this->_orderDirImage($this->lists['order'], 'i.name', $this->lists['order_Dir']); ?></a>
					<?php } else { echo JText::_('COM_DJCATALOG_NAME'); } ?>
                </td>
				<?php if ($this->params->get('items_show_intro')) {?>
                <td class = "djcat_th_intro">
                    <?php echo JText::_('COM_DJCATALOG_DESCRIPTION'); ?>
                </td>
				<?php } ?>
				<?php if ($this->params->get('show_category_name') > 0) { ?>
					<td class="djcat_th_category" nowrap="nowrap">
						<?php if ($this->params->get('show_category_orderby') > 0) { ?>
							<a href="<?php echo JRoute::_( $orderUrl.'&order=category&dir='.$this->lists['order_Dir'].'#djcat_table'); ?>"><?php echo JText::_('COM_DJCATALOG_CATEGORY'); ?><?php echo $this->_orderDirImage($this->lists['order'], 'category', $this->lists['order_Dir']); ?></a>
						<?php } else {echo JText::_('COM_DJCATALOG_CATEGORY');} ?>
					</td>
				<?php } ?>
				<?php if ($this->params->get('show_producer_name') > 0) { ?>
					<td class="djcat_th_producer" nowrap="nowrap">
						<?php if ($this->params->get('show_producer_orderby') > 0) { ?>
							<a href="<?php echo JRoute::_( $orderUrl.'&order=producer&dir='.$this->lists['order_Dir'].'#djcat_table'); ?>"><?php echo JText::_('COM_DJCATALOG_PRODUCER'); ?><?php echo $this->_orderDirImage($this->lists['order'], 'producer', $this->lists['order_Dir']); ?></a>
						<?php } else {echo JText::_('COM_DJCATALOG_PRODUCER');} ?>
					</td>
				<?php } ?>
				<?php if ($this->params->get('show_price') > 0) { ?>
                <td class="djcat_th_price" nowrap="nowrap">
                	<?php if ($this->params->get('show_price_orderby') > 0) { ?>
                   		<a href="<?php echo JRoute::_( $orderUrl.'&order=i.price&dir='.$this->lists['order_Dir'].'#djcat_table'); ?>"><?php echo JText::_('COM_DJCATALOG_PRICE'); ?><?php echo $this->_orderDirImage($this->lists['order'], 'i.price', $this->lists['order_Dir']); ?></a>
					<?php } else {echo JText::_('COM_DJCATALOG_PRICE');} ?>
                </td>
				<?php } ?>
            </tr>
        	<?php
			$k = 1;
			foreach($this->items as $item){
				$k = 1 - $k;
				?>
	        <tr class="djcat_table_row<?php echo $k;?>">
	            <td class="djcat_td_image">
	                <?php if ($item->images = $this->images->getImages($item->image_url)) { ?>
			        	<div class="djcat_td_image_in">
			        		<?php if ($this->params->get('image_link_item')) { ?>
								<a rel="lightbox-djitem" title="<?php echo $item->name?>" href="<?php echo $item->images[0]['original']?>"><img alt="<?php echo $item->name; ?>" src="<?php echo $item->images[0]['small']; ?>"/></a>
							<?php } else { ?>
								<a href="<?php echo JRoute::_(DJCatalogHelperRoute::getItemRoute($item->slug, $item->catslug)); ?>"><img alt="<?php echo $item->name; ?>" src="<?php echo $item->images[0]['small']; ?>"/></a>
				        	<?php } ?>
			        	</div>
					<?php } ?>
	            </td>
				<td class="djcat_td_title" nowrap="nowrap">
	                <?php  echo (JHTML::link(JRoute::_(DJCatalogHelperRoute::getItemRoute($item->slug, $item->catslug)), $item->name)); ?>
	            </td>
				<?php if ($this->params->get('items_show_intro')) {?>
				<td class="djcat_intro">
					<?php if ($this->params->get('items_intro_length') > 0 ) {
							echo DJCatalogHelper::trimText($item->intro_desc, $this->params->get('items_intro_length'));
						}
						else {
							echo $item->intro_desc; 
						}
					?>
				 </td>
				<?php } ?>
				<?php if ($this->params->get('show_category_name') > 0) { ?>
						<td class="djcat_td_category">
							<?php 
								if ($this->params->get('show_category_name') == 2) {
			            			?><span class="djcat_category"><?php echo $item->category; ?></span> 
								<?php }
								else {
									?><a href="<?php echo DJCatalogHelperRoute::getCategoryRoute($item->catslug,'itemstable');?>"><span class="djcat_category"><?php echo $item->category; ?></span></a> 
								<?php } ?>
						</td>
					<?php } ?>
					<?php if ($this->params->get('show_producer_name') > 0) { ?>
						<td class="djcat_td_producer">
							<?php 
								if ($this->params->get('show_producer_name') == 2 && $item->producer) {
			            			?><span class="djcat_producer"><?php echo $item->producer;?></span>
								<?php }
								else if(($this->params->get('show_producer_name') == 3 && $item->producer)) {
									?><a class="modal" rel="{handler: 'iframe', size: {x: 800, y: 600}}" href="<?php echo JRoute::_(DJCatalogHelperRoute::getProducerRoute($item->prodslug).'&tmpl=component'); ?>"><span class="djcat_producer"><?php echo $item->producer; ?></span></a> 
								<?php }
								else if ($item->producer){
									?><a href="<?php echo JRoute::_(DJCatalogHelperRoute::getProducerRoute($item->prodslug)); ?>"><span class="djcat_producer"><?php echo $item->producer; ?></span></a>
								<?php } ?>
						</td>
					<?php } ?>
				<?php if ($this->params->get('show_price') > 0) { ?>
	            <td class="djcat_td_price" nowrap="nowrap">
	                <?php
					if ($item->price > 0.0) {
						if ($this->params->get('unit_side')== 1) {
							$item->price = number_format($item->price, 2, $this->price_decimal_separator, $this->price_thousands_separator).' '.$this->params->get('price_unit');
						}
						else {
							$item->price = $this->params->get('price_unit').' '.number_format($item->price, 2, $this->price_decimal_separator, $this->price_thousands_separator);
						}
						echo $item->price;
					}?>
	            </td>
				<?php }?>
	        </tr>
	        <?php
			}
        ?>
	    </table>
		 <div class="djcat_blog_pagination">
	        <?php
	        echo $this->pagination->getPagesLinks();
	        ?>
	    </div>
		<div class="clearfix clr clear"> </div>
	<?php } ?>
	<?php 
		if ($this->params->get('show_footer')) echo DJCATFOOTER;
	?>
</div>
