<?php
/**
* @license		GNU/GPL, see LICENSE.php
* @author		Benjamin Jeanjean <benjamin.jeanjean@gmail.com>
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

/** 
 * JFolder extension class 
 * 
 */ 
class JFolderWCP { 
    /** 
     * Utility function to read the files in a folder. 
     * 
     * @param string The full path of the folder to read 
     * @param array The exclude list 
     * @return array Files and folders in the given folder 
     * @access public 
     */ 
    function files($path, $filter, $recurse, $fullpath, $exclude = array('.svn', 'CVS')) { 
        // Initialize variables 
        $arr = array(); 

        // read the source directory 
        $handle = opendir($path); 
        while(($file = readdir($handle)) !== false) { 
            if($file != '.' and $file != '..' and !in_array($file, $exclude)) { 
                $dir = $path . DS . $file; 
                if(!in_array($dir, $exclude)) { 
                    if(is_dir($dir)) {
											if ($recurse) {
                        $arr = array_merge($arr, JFolderWCP::files($dir, $filter, $recurse, $fullpath, $exclude));
                      }
                    } else {
	                    if (preg_match("/$filter/", $file)) {
												if ($fullpath) {
													$arr[] = $dir;
												} else {
													$arr[] = $file;
												}
											}
										}
                } 
            } 
        } 
        closedir($handle);
        return $arr; 
    }
}

class modRandomImagePlusImage {
	var $_fullPath = null;

	function modRandomImagePlusImage($fullPath) 
	{
		$this->_fullPath = $fullPath;
		$this->uri = $this->_getURI();
	}

	function _getURI() 
	{
		$uri = false;
		if (JString::strpos($this->_fullPath, JPATH_SITE) !== false) {
			$folderSanitized = str_replace(JPATH_SITE, '', $this->_fullPath);
			$folderSanitized = ltrim($folderSanitized, '\/');
			$folderSanitized = rtrim($folderSanitized, '\/');
	    	$uri = JURI::base() . $folderSanitized;
	    	$uri = str_replace(DS, '/', $uri);
	    } 
		return $uri;
	}
}