<?php
/**
 * @name mosets_kinabalu
 * @copyright Copyright (C) Mosets Consulting
 * @license GNU/GPL
 * @share joomfans.com
 */
defined('_JEXEC') or die('Restricted access');

$template_url 	= $this->baseurl . "/templates/" . $this->template;
$show_topbutton = ($this->params->get("showTopbutton", 1)  == 0)?"false":"true";
$show_copyright = ($this->params->get("showCopyright", 1)  == 0)?"false":"true";
$hasRightCol 	= ($this->countModules('right')?true:false);
$hasLeftCol 	= ($this->countModules('left')?true:false);
$mainColWidth 	= 1000;

if( $hasLeftCol ) { $mainColWidth -= 160; }
if( $hasRightCol ) { $mainColWidth -= 260; }

echo '<?xml version="1.0" encoding="utf-8"?'.'>';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language ?>" dir="<?php echo $this->direction; ?>">
<head>
<jdoc:include type="head" />

<link rel="stylesheet" type="text/css" href="<?php echo $template_url; ?>/css/template_css.css" media="screen, projection" />
<link rel="stylesheet" type="text/css" href="<?php echo $template_url; ?>/css/layout.css" media="screen, projection" />

<!--[if lte IE 6]>
<link rel="stylesheet" type="text/css" href="<?php echo $template_url; ?>/css/ie6.css" />
<![endif]-->
<!--[if IE 7]>
<link rel="stylesheet" type="text/css" href="<?php echo $template_url; ?>/css/ie7.css" />
<![endif]-->

</head>
<body>
	<div id="header">
		<div id="header-inner">
			<div id="logo"><a href=""><img src="<?php echo $template_url; ?>/images/logo.png"></a></div>
			<div id="header-nav">
				<jdoc:include type="modules" name="top" style="raw" />
			</div>
			<div class="user3"><jdoc:include type="modules" name="user3" style="xhtmlenhanced" /></div>
			<div class="user4"><jdoc:include type="modules" name="user4" style="xhtmlenhanced" /></div>
		</div>
	</div>
	<div id="wrapper">
		<div id="contentarea">
			<?php if($this->countModules('left')) : ?>
			<div id="leftcol">
				<div class="leftcol2">
					<!--load a module-->
					<jdoc:include type="modules" name="left" style="xhtmlenhanced" />
				</div>
			</div>
			<?php endif; ?>
			<div id="maincol" style="width:<?php echo $mainColWidth; ?>px">
				<jdoc:include type="message" />
				<div class="maincol2"><?php 
					
					if($this->countModules('breadcrumb')) : 
					?>				
					<!--pathway-->
					<div id="breadcrumbs">
						<jdoc:include type="modules" name="breadcrumb" style="raw" />
					</div><?php
					endif;
					
					if($this->countModules('main-feature')) : 
					?>				
					<div id="main-feature" class="columns1-modules-inner">
						<jdoc:include type="modules" name="main-feature" style="xhtmlenhanced" />
					</div><?php
					endif;
					
					if($this->countModules('main2')) : 
					?>				
					<div id="main-modules" class="columns2-modules-inner">
						<jdoc:include type="modules" name="main2" style="xhtmlenhanced" />
					</div><?php
					endif;
					
					?>
					<!--mainframe-->
					<jdoc:include type="component" /><?php
					
					if($this->countModules('main-feature2')) : 
					?>				
					<div id="main-feature2" class="columns1-modules-inner">
						<jdoc:include type="modules" name="main-feature2" style="xhtmlenhanced" />
					</div><?php
					endif;
					
					if($this->countModules('main2-footer')) : 
					?>				
					<div id="main-modules2">
						<jdoc:include type="modules" name="main2-footer" style="xhtmlenhanced" />
					</div><?php
					endif;
					?>
				</div>
			</div>
			<?php if($this->countModules('right')) : ?>
			<div id="rightcol">
				<div class="rightcol2">
					<!--load a module-->
					<jdoc:include type="modules" name="right" style="xhtmlenhanced" />
				</div>
			</div>
			<?php endif; ?>
		</div>
	</div><?php 
	
	if(
		$this->countModules('footer') || $this->countModules('footer2') || $this->countModules('footer3') || $this->countModules('footer4') || $this->countModules('footer5') || $this->countModules('footer6')
	) : 
	?>	
	<div id="footer"><?php
		if($this->countModules('footer')) : 
		?>
		<div class="columns1-modules-inner">
			<jdoc:include type="modules" name="footer" style="footer" />
		</div><?php 
		endif;

		if($this->countModules('footer2')) : 
		?>
		<div class="columns2-modules-inner">
			<jdoc:include type="modules" name="footer2" style="footer" />
		</div><?php 
		endif;
		
		if($this->countModules('footer3')) : 
		?>
		<div class="columns3-modules-inner">
			<jdoc:include type="modules" name="footer3" style="footer" />
		</div><?php 
		endif;

		if($this->countModules('footer4')) : 
		?>
		<div class="columns4-modules-inner">
			<jdoc:include type="modules" name="footer4" style="footer" />
		</div><?php 
		endif;
		?>
	</div><?php 
	endif; 
	
	if($this->countModules('user1') || $this->countModules('user2') || $this->countModules('user3') || $this->countModules('user5') || $this->countModules('user6')) : 
	?>
	<div id="bottom">
		<div id="bottom-inner">
			<jdoc:include type="modules" name="user1" style="bottom" />
			<jdoc:include type="modules" name="user2" style="bottom" />
			<jdoc:include type="modules" name="user3" style="bottom" />
			<jdoc:include type="modules" name="user5" style="bottom" />
			<jdoc:include type="modules" name="user6" style="bottom" />
		</div>
	</div><?php 
	endif;
	
	?>
	<div id="footer">
		<?php if ($show_copyright == "true") : ?>
		<div class="copyright">
			<a href="http://www.mosets.com/" title="<?php echo JText::_('COMPANY NAME'); ?>"><?php echo JText::_('COMPANY NAME'); ?></a>
			<span id="copyright">
				&copy; <?php echo JText::_('COPYRIGHT'); ?>
			</span>
		</div>
		<?php else: ?>
		<div class="footer-mod">
			<jdoc:include type="modules" name="footer5" style="xhtmlenhanced" />
		</div>
		<?php endif; ?>
		<?php if ($show_topbutton == "true") : ?>
		<div id="top-button"><a href="#" id="top-scroll"><?php echo JText::_('TOP'); ?></a></div>
		<?php endif; ?>
		<jdoc:include type="modules" name="debug" style="none" />
	</div>
</body>
</html>
